ASSEMBLE
	NIBASC /HPHP48-R/
RPL
::
	CK1&Dispatch
	#C :: 
	RECLAIMDISP		
	ClrDA1IsStat
	CODE
* System Initialization
	  GOSBVL =SAVPTR                        * Save RPL pointers
	  GOSBVL =DisableIntr                   * Disable interrupts

* Display Initialization
	  D0=(5) #00128                         * Load D0 with display row count        
	  LC(2) #3F                             * Load C with count of 63
	  DAT0=C B                              * Kill the menu

* Program Initialization
	  ST=0 0                                * Clear program flag 0 
	  A=DAT1 A                              * Load A(A) with the address of the 
	  A=A+CON A,#0A                  *  grob in level 1 and skip the
	  A=A+CON A,#0A                   *  prolog
	  ?ABIT=0 0                             * Grob data on even address?
	  GOYES Pair                            * Yes, jump
	  ST=1 0                                * No, set program flag 1
	  LC(5) #01100                          * Load C with copy count (#01100)
	  A=A+C A                               * Add this to A(A)...
	  D1=A                                  * ...and put it in D1
	  A=A-1 A                               * Subtract one from this...
	  D0=A                                  * ...and put it in D0
	  GOSBVL =MOVEUP                        * Copy up, D0 -> D1
	  AD1EX                                 * Swap A and D1
	  A=A+1 A                               * Add 1 to A
	
Pair
	  R0=A A                                * Ensure grobs can be restored
	  R1=A A                                * Load R1 with first grob
	  LC(5) #00880                          * Load C(A) with offset
	  A=A+C A                               * Add grob offset to A(A) 
	  R2=A A                                * Load R2 and R3 with second grob
	  R3=A A
	  D1=(5) #00128                         * Set D1 to display row count
	
* Main Program Loop
MainLoop
	  GOSUB RotateGrob                      * Run grob-swapping routine
	  GOSUB CheckKey                        * Check for a keypress
	  ?C=0 A                                * No keys pressed?
	  GOYES MainLoop                        * Yes, loop again
  
	  ?ST=0 0                               * Key pressed, check if grob pair
	  GOYES NoMove                          * Yes, no need to move      
	  A=R0 A                                * Restore A(A) from R0(A)
	  D0=A                                  * Put this into D0
	  A=A-1 A                               * Subtract 1 from A(A)
	  D1=A                                  * Put this into D1
	  LC(5) #01100                          * Load copy count into C(A)
	  GOSBVL =MOVEDOWN                      * Copy down, D0 -> D1
	
NoMove
	  GOSBVL =D0->Row1                      * Restore old screen address to A(A) 
	  D0=(5) #00120                         * Load D0 with display address base
	  DAT0=A A                              * Restore original display address
	  D0=(5) #00128                         * Load D0 with display row count
	  LC(2) #37                             * Load C with new count
	  DAT0=C B                              * Restore the bottom menu  
	  GOSBVL =AllowIntr                     * Restore interrupts
	  GOSBVL =FlushAttn                     * Flush ON-key presses
	  GOSBVL =Flush                         * Flush keypresses
	  GOVLNG =GETPTRLOOP                    * Return to RPL

* Rotates the current grob address through the three loaded before (R1..3)
RotateGrob
	  A=R3 A                                * Load A(A) with next grob       
	  AR2EX A                               * Rotate current grob through the
	  AR1EX A                               *  other three loaded before
	  R3=A A                                * A(A) points to current grob
	  D0=(5) #00120                         * Load D0 with display address base
	  DAT0=A A                              * Show current grob

	  A=DAT1 B                              * Read byte from display scan row 
	  LC(2) #C0                             * Load C(1-2) with mask #1100 0000h
	  A=A&C B                               * Save DA19 and M32 with mask
	  C=A B                                 * Load C with this value
	  LC(1) #A                              * Load C(1) with #Ah (LCD row 10)

* Vertical blanking loop: ensures that routine always exits with retrace on 
* LCD row 10
VBlankLoop1
	  A=DAT1 B                              * Read a byte at [D1]
	  ?A>C B                                * Is the retrace below row 10?
	  GOYES VBlankLoop1                     * Yes, wait until it returns to start
   
VBlankLoop2
	  A=DAT1 B                              * Read a byte at [D1]
	  ?A<=C B                               * Is the retrace above row 10?
	  GOYES VBlankLoop2                     * Yes, wait until it passes row 10 
	  RTN                                   * Return to main loop

* Check for keypress routine: required, as interrupts are disabled
CheckKey
	  LC(5) #001FF                          * Load C with keymask
	  GOVLNG #01EEC                         * Put key matrix into C(A), return
	ENDCODE
	ClrDAsOK
	;
;
