* Contrast-setting Utility v1.0
* Written by Matthew Mastracci (12/31/97)
* Placed in the public domain

* Takes nothing on the stack, leaves nothing on the stack
* ( --> )
ASSEMBLE
	NIBASC /HPHP48-R/
RPL
::
  ClrDA1IsStat
	RECLAIMDISP		
	TURNMENUOFF
	0 0
	63 131 MAKEGROB
	XYGROBDISP
	3 29
	128 29
	LINEON
	3 35
	128 35
	LINEON
	3 30
	3 34
	LINEON
 	128 30 
	128 34
	LINEON
* This is where the default (first power-on) contrast is set
	59 27
	59 37
	LINEON
	HARDBUFF
	66 1 "Contrast Utility"
	131 CENTER$3x5
	66 52	"Use \8E and \8D to change contrast"
  131 CENTER$3x5		
	66 58	"Press ON when finished"
	131 CENTER$3x5 	
	CODE
	  GOSBVL =SAVPTR                        * Save RPL pointers
	  GOSBVL =DisableIntr                   * Disable interrupts
		INTOFF

* Get the address of HARDBUFF from the stack
		A=DAT1 A
		LC(5) 1041
		A=A+C A

* Make D1 point to first nibble of contrast bar
		D1=A

* Clear busy annunciator
		D0=(5) #0010C
		P= 0
		LC(1) #8
		DAT0=C P

* Initial update of contrast bar		
		GOSUBL LoadA
		GOLONG UpdateStatusBar

* Key repeat counter
		B=0 A

* Start of our key loop
GetKey
		C=0 W																	* Just need ON key
		OUT=C
		GOSBVL =CINRTN												* C=IN (calls from even address)
* NOTE: the ON-key is returned in bit 15 of C at this point, whether we want
* 			it or not.  Make sure you don't make any assumptions about which key
*				is pressed by testing with "C#0?"
		?C=0 A																* If zero, not pressed
		GOYES CheckIncrease

* ON pressed, quit program
Quit
		INTON
	  GOSBVL =AllowIntr                     * Restore interrupts
	  GOSBVL =FlushAttn                     * Flush ON-key presses
	  GOSBVL =Flush                         * Flush keypresses
	  GOVLNG =GETPTRLOOP                    * Return to RPL

CheckIncrease
		LC(3) #040														* Mask row with left/right
		OUT=C
		GOSBVL =CINRTN												* C=IN (calls from even address)
		LA(2) #01															* Left-arrow column mask
		?C#A B																* If not equal, key is not pressed
		GOYES CheckDecrease										*   or pressed with other key 

* Right arrow pressed, increase contrast
Increase
		B=B+1 A																* Increase key-repeat counter
		LC(5) #01000
		?B<C A																* Held down long enough?
		GOYES GetKey
		GOSUB LoadA														* Yes, load A with contrast setting
		LC(2) #1F
		?A=C B																* Is A already at largest value?
		GOYES GetKey
		A=A+1 B																* No, increase and set it
		DAT0=A B
		GOTO UpdateStatusBar									* Update status bar with new value

CheckDecrease
		LA(2) #04															* Right-arrow column mask
		?C#A B																* Check key
		GOYES CheckOver

* Left arrow pressed, decrease contrast
Decrease	
		B=B+1 A																* Increase key-repeat counter
		LC(5) #01000
		?B<C A																* Held down long enough?
		GOYES JumpBack
		GOSUB LoadA														* Yes, load A with contrast setting
		?A=0 B																* Is A already at smallest value?
		GOYES JumpBack
		A=A-1 B																* No, decrease and set it
		DAT0=A B
		GOTO UpdateStatusBar									* Update status bar with new value

* No key currently pressed, no need to wait for next key
CheckOver
		LC(5) #01000
		B=C A
JumpBack
		GOLONG GetKey
* End of key loop

* On entry: 
* D1:		Points to bar [restored]
* A[B]:	Current contrast setting [not restored]
		
* Internal usage:
* D1:	Current nibble to draw at
* A:	Holds start of bar
* B:	Holds current contrast level
* C:	P-field holds 0Fh
* D:	Inner loop counter (col)
* P:	Outer loop counter (row)
* R1: Saves C

* This took a while to get right  :)
UpdateStatusBar
		B=A A																	* B now holds contrast
		AD1EX
* P holds our row loop counter
		P= #B
		C=0 W																	* Load C with #FFFFFFFFFFFFFFFF
		C=C-1 W																
		D1=A																	* D1 points to start of bar
RowLoop
		?B=0 B																* Contrast zero?
		GOYES SkipColLoop											* No need to draw solid part
* D=B A, which is: (ugh)
		R1=C
		C=B A
		D=C A
		C=R1
ColLoop
		DAT1=C P															* Write the current row-block
		D1=D1+ #1															* Next row-block
		D=D-1 B																* Decrement column index
		?D#0 B																* Are we done?
		GOYES ColLoop													* Nope, do it again
SkipColLoop
		D=0 A																	* D=(31-contrast) (blank area width)
		D=D+CON A,#0F
		D=D+CON A,#0F
		D=D+1 A
		R1=C
		C=B A
		D=D-C A
		C=R1
		?D=0 B																* Is the bar full?
		GOYES SkipColLoop2										* No need to draw blank part
		
		C=C+1 W																* Load C with #0000000000000000
ColLoop2
		DAT1=C P															* Write the current row-block like before
		D1=D1+ #1
		D=D-1 B
		?D#0 B
		GOYES ColLoop2
		C=C-1 W																* Load C with #FFFFFFFFFFFFFFFF

SkipColLoop2
		D1=D1+ 3															* Go to next row
		P=P+1																	* Increment row index
		GONC RowLoop													* Loop if P is not zero
		B=0 A																	* Zero key-repeat counter
		D1=A																	* Restore D1
		GOLONG GetKey	

LoadA		
		D0=(5) #00101													* Load contrast by from 00101h
		A=DAT0 B
		RTN
	ENDCODE
	DROP
	ClrDAsOK
;
