// HPIDE.cpp : Defines the class behaviors for the application.
//

#include "stdafx.h"
#include "HPIDE.h"

#include "SourceDocument.h"
#include "SourceEditView.h"
#include "ProjectDocument.h"
#include "ProjectEditView.h"
#include "TipDlg.h"
#include "MainFrm.h"
#include "ChildFrm.h"
#include <dos.h>
#include <direct.h>

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CHPIDEApp

BEGIN_MESSAGE_MAP(CHPIDEApp, CWinApp)
	//{{AFX_MSG_MAP(CHPIDEApp)
	ON_COMMAND(ID_APP_ABOUT, OnAppAbout)
		// NOTE - the ClassWizard will add and remove mapping macros here.
		//    DO NOT EDIT what you see in these blocks of generated code!
	//}}AFX_MSG_MAP
	// Standard file based document commands
	ON_COMMAND(ID_FILE_NEW, CWinApp::OnFileNew)
	ON_COMMAND(ID_FILE_OPEN, CWinApp::OnFileOpen)
	// Standard print setup command
	ON_COMMAND(ID_FILE_PRINT_SETUP, CWinApp::OnFilePrintSetup)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CHPIDEApp construction

CHPIDEApp::CHPIDEApp()
{
	// TODO: add construction code here,
	// Place all significant initialization in InitInstance
}

/////////////////////////////////////////////////////////////////////////////
// The one and only CHPIDEApp object

CHPIDEApp theApp;

/////////////////////////////////////////////////////////////////////////////
// CHPIDEApp initialization

BOOL CHPIDEApp::InitInstance()
{
	// Standard initialization
	// If you are not using these features and wish to reduce the size
	//  of your final executable, you should remove from the following
	//  the specific initialization routines you do not need.

#ifdef _AFXDLL
	Enable3dControls();			// Call this when using MFC in a shared DLL
#else
	Enable3dControlsStatic();	// Call this when linking to MFC statically
#endif

	LoadStdProfileSettings(5);  // Load standard INI file options (including MRU)

	m_SourceFont.CreatePointFont(100, "Courier New");
	m_TipFont.CreatePointFont(100, "Arial");
	m_ComboFont.Attach(::GetStockObject(DEFAULT_GUI_FONT));
	// Register the application's document templates.  Document templates
	//  serve as the connection between documents, frame windows and views.
	CMultiDocTemplate* pSrcDocTemplate;
	pSrcDocTemplate = new CMultiDocTemplate(
		IDR_SOURCETYPE,
		RUNTIME_CLASS(CSourceDocument),
		RUNTIME_CLASS(CChildFrame), // custom MDI child frame
		RUNTIME_CLASS(CSourceEditView));
	AddDocTemplate(pSrcDocTemplate);
	CMultiDocTemplate* pPrjDocTemplate;
	pPrjDocTemplate = new CMultiDocTemplate(
		IDR_PROJECTTYPE,
		RUNTIME_CLASS(CProjectDocument),
		RUNTIME_CLASS(CChildFrame), // custom MDI child frame
		RUNTIME_CLASS(CProjectEditView));
	AddDocTemplate(pPrjDocTemplate);

	// create main MDI Frame window
	CMainFrame* pMainFrame = new CMainFrame;
	if (!pMainFrame->LoadFrame(IDR_MAINFRAME))
		return FALSE;
	pMainFrame->m_pSourceTemplate = (CDocTemplate*)pSrcDocTemplate;
	pMainFrame->m_pProjectTemplate = (CDocTemplate*)pPrjDocTemplate;
	m_pMainWnd = pMainFrame;

	// Enable drag/drop open
	m_pMainWnd->DragAcceptFiles();

	// Enable DDE Execute open
	EnableShellOpen();
	RegisterShellFileTypes(TRUE);

	// Parse command line for standard shell commands, DDE, file open
	CCommandLineInfo cmdInfo;
	ParseCommandLine(cmdInfo);

	// Dispatch commands specified on the command line (except FileNew)
	if (cmdInfo.m_nShellCommand != CCommandLineInfo::FileNew)
		if (!ProcessShellCommand(cmdInfo))
			return FALSE;

	// The main window has been initialized, so show and update it.
	pMainFrame->ShowWindow(SW_SHOWMAXIMIZED);
	pMainFrame->UpdateWindow();
	pMainFrame->RecalcLayout();
/*
	// Put the message window in the bottom third of the visible area
	RECT rect;
	pMainFrame->GetClientRect(&rect);
	rect.top = rect.bottom * 2 / 3;
	pMainFrame->ClientToScreen(&rect);
	CRect StatusRect, WndRect;
	pMainFrame->m_wndStatusBar.GetClientRect(&StatusRect);
	pMainFrame->m_wndStatusBar.ClientToScreen(&StatusRect);
	WndRect.SubtractRect(&rect, StatusRect);
	pMainFrame->m_pBuildMessageDialog->MoveWindow(&WndRect, TRUE);
*/
//	pMainFrame->m_wndMessageDialogBar.CalcDynamicLayout(WndRect.Width(), LM_HORZ);
//	pMainFrame->m_wndMessageDialogBar.CalcDynamicLayout(WndRect.Height(), LM_VERTDOCK);
	if (pMainFrame->GetSettingBool("ShowTips"))
	{
		// Disable until I figure out what to do with this
//		pMainFrame->m_pSplashScreenDialog->SetFocus();
		pMainFrame->m_pSplashScreenDialog->GoAway();
		ShowTipAtStartup();
//		CTipDialog dlg(pMainFrame);
//		dlg.DoModal();
	}
	// CG: This line inserted by 'Tip of the Day' component.

	return TRUE;
}

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	virtual BOOL OnInitDialog();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

// App command to run the dialog
void CHPIDEApp::OnAppAbout()
{
	CAboutDlg aboutDlg;
	aboutDlg.DoModal();
}

/////////////////////////////////////////////////////////////////////////////
// CHPIDEApp commands

BOOL CAboutDlg::OnInitDialog() 
{
	// CG: Folowing code is added by System Info Component
	{
	CDialog::OnInitDialog();
#ifndef _MAC
	CString strFreeDiskSpace;
	CString strFreeMemory;
	CString strFmt;

	// Fill available memory
	MEMORYSTATUS MemStat;
	MemStat.dwLength = sizeof(MEMORYSTATUS);
	GlobalMemoryStatus(&MemStat);
	strFmt.LoadString(IDS_PHYSICAL_MEM);
	strFreeMemory.Format(strFmt, MemStat.dwTotalPhys / 1024L);

	SetDlgItemText(IDC_ABOUT_FREEMEMORY, strFreeMemory);

	// Fill disk free information
	struct _diskfree_t diskfree;
	int nDrive = _getdrive(); // use current default drive
	if (_getdiskfree(nDrive, &diskfree) == 0)
	{
		strFmt.LoadString(IDS_DISK_SPACE);
		strFreeDiskSpace.Format(strFmt,
			(DWORD)diskfree.avail_clusters *
			(DWORD)diskfree.sectors_per_cluster *
			(DWORD)diskfree.bytes_per_sector / (DWORD)1024L,
			nDrive-1 + _T('A'));
	}
 	else
 		strFreeDiskSpace.LoadString(IDS_DISK_SPACE_UNAVAIL);

	SetDlgItemText(IDC_ABOUT_FREEDISKSPACE, strFreeDiskSpace);

#endif //_MAC
	}

	CDialog::OnInitDialog();
	
	CMainFrame * pWnd = ((CMainFrame *)AfxGetMainWnd());
	int RegValue = pWnd->CheckRegistration(
		pWnd->GetSettingString("RegName"), 
		pWnd->GetSettingString("RegKey"));
	CString Name = pWnd->GetSettingString("RegName");
	CString Key = pWnd->GetSettingString("RegKey");
	if (RegValue == REG_COMMERCIAL)
		Key += " (commercial user)";
	if (RegValue == REG_NONCOMMERCIAL)
		Key += " (non-commercial user)";
	if (RegValue == REG_INVALID)
		Key += " (invalid key)";
	SetDlgItemText(IDC_ABOUT_REGNAME, Name);
	SetDlgItemText(IDC_ABOUT_REGKEY, Key);
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

BOOL CHPIDEApp::PreTranslateMessage(MSG* pMsg)
{
	return CWinApp::PreTranslateMessage(pMsg);
}

void CHPIDEApp::ShowTipAtStartup(void)
{
	// CG: This function added by 'Tip of the Day' component.

	CCommandLineInfo cmdInfo;
	ParseCommandLine(cmdInfo);
	if (cmdInfo.m_bShowSplash)
	{
		CTipDlg dlg;
		if (dlg.m_bStartup)
			dlg.DoModal();
	}

}

void CHPIDEApp::ShowTipOfTheDay(void)
{
	// CG: This function added by 'Tip of the Day' component.

	CTipDlg dlg;
	dlg.DoModal();

}
