// MainFrm.cpp : implementation of the CMainFrame class
//

#include "stdafx.h"
#include "HPIDE.h"

#include "ProjectDocument.h"
#include "ProjectSettingsDialog.h"
#include "ProgramSettingsDialog.h"
#include "BuildProgressDialog.h"
#include "TransferInProgressDialog.h"
#include "CancelBuildThread.h"
#include "EditTemplateDialog.h"
#include "MainFrm.h"
#include "ProjectEditView.h"
#include "EditFilenameDialog.h"
#include "TipDlg.h"
#include "CoolMenu.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CMainFrame

IMPLEMENT_DYNAMIC(CMainFrame, CMDIFrameWnd)

BEGIN_MESSAGE_MAP(CMainFrame, CMDIFrameWnd)
	//{{AFX_MSG_MAP(CMainFrame)
	ON_WM_CREATE()
	ON_COMMAND(ID_PROJECT_CLOSEPROJECT, OnProjectCloseproject)
	ON_COMMAND(ID_PROJECT_NEWPROJECT, OnProjectNewproject)
	ON_COMMAND(ID_PROJECT_OPENPROJECT, OnProjectOpenproject)
	ON_COMMAND(ID_PROJECT_SAVEPROJECT, OnProjectSaveproject)
	ON_UPDATE_COMMAND_UI(ID_PROJECT_CLOSEPROJECT, OnUpdateProjectCloseproject)
	ON_UPDATE_COMMAND_UI(ID_PROJECT_NEWPROJECT, OnUpdateProjectNewproject)
	ON_UPDATE_COMMAND_UI(ID_PROJECT_OPENPROJECT, OnUpdateProjectOpenproject)
	ON_UPDATE_COMMAND_UI(ID_PROJECT_SAVEPROJECT, OnUpdateProjectSaveproject)
	ON_COMMAND(ID_FILE_NEWSOURCE, OnFileNew)
	ON_UPDATE_COMMAND_UI(ID_FILE_NEWSOURCE, OnUpdateFileNew)
	ON_UPDATE_COMMAND_UI(ID_PROJECT_PROJECTSETTINGS, OnUpdateProjectProjectsettings)
	ON_COMMAND(ID_PROJECT_PROJECTSETTINGS, OnProjectProjectsettings)
	ON_COMMAND(ID_FILE_SAVEALL, OnFileSaveall)
	ON_COMMAND(ID_BUILD_BUILDPROJECT, OnBuildBuildproject)
	ON_UPDATE_COMMAND_UI(ID_BUILD_BUILDPROJECT, OnUpdateBuildBuildproject)
	ON_COMMAND(ID_VIEW_OPTIONS, OnViewOptions)
	ON_COMMAND(ID_HELP_TIPOFTHEDAY, OnHelpTipoftheday)
	ON_COMMAND(ID_BUILD_TRANSFERPROJECT, OnBuildTransferproject)
	ON_UPDATE_COMMAND_UI(ID_BUILD_TRANSFERPROJECT, OnUpdateBuildTransferproject)
	ON_COMMAND(ID_FILE_TRANSFERFILE, OnFileTransferfile)
	ON_UPDATE_COMMAND_UI(ID_BUILD_CANCELBUILD, OnUpdateBuildCancelbuild)
	ON_COMMAND(ID_BUILD_CANCELBUILD, OnBuildCancelbuild)
	ON_UPDATE_COMMAND_UI(ID_PROJECT_ADDFILEFROMDISK, OnUpdateProjectAddfilefromdisk)
	ON_COMMAND(ID_PROJECT_ADDFILEFROMDISK, OnProjectAddfilefromdisk)
	ON_UPDATE_COMMAND_UI(ID_PROJECT_CURRENTCONFIG, OnUpdateProjectCurrentconfig)
	ON_CBN_SELCHANGE(ID_PROJECT_CURRENTCONFIG, OnSelchangeCurrentConfig)
	ON_UPDATE_COMMAND_UI(ID_BUILD_SIMULATEPROJECT, OnUpdateBuildSimulateproject)
	ON_COMMAND(ID_BUILD_SIMULATEPROJECT, OnBuildSimulateproject)
	ON_COMMAND(ID_EDIT_TEMPLATES_EDIT, OnEditTemplatesEdit)
	ON_WM_KEYDOWN()
	//}}AFX_MSG_MAP
	// Global help commands
	ON_COMMAND(ID_HELP_FINDER, CMDIFrameWnd::OnHelpFinder)
	ON_COMMAND(ID_HELP, CMDIFrameWnd::OnHelp)
	ON_COMMAND(ID_CONTEXT_HELP, CMDIFrameWnd::OnContextHelp)
	ON_COMMAND(ID_DEFAULT_HELP, CMDIFrameWnd::OnHelpFinder)

	ON_UPDATE_COMMAND_UI(ID_VIEW_MESSAGES, OnUpdateControlBarMenu)
	ON_COMMAND_EX(ID_VIEW_MESSAGES, OnBarCheck)
	ON_UPDATE_COMMAND_UI(ID_VIEW_TOOLBARS_MAIN, OnUpdateControlBarMenu)
	ON_COMMAND_EX(ID_VIEW_TOOLBARS_MAIN, OnBarCheck)
	ON_UPDATE_COMMAND_UI(ID_VIEW_TOOLBARS_PROJECT, OnUpdateControlBarMenu)
	ON_COMMAND_EX(ID_VIEW_TOOLBARS_PROJECT, OnBarCheck)
END_MESSAGE_MAP()

static UINT indicators[] =
{
	ID_SEPARATOR,           // status line indicator
	ID_INDICATOR_LOCATION,
	ID_INDICATOR_CAPS,
	ID_INDICATOR_NUM,
	ID_INDICATOR_SCRL,
};

struct TRANSLATE_ENTRY
{
	TRANSLATE_ENTRY(int c, const char* s) : CharNum(c), Code(s) {}
	char CharNum;
	CString Code;
};

const TRANSLATE_ENTRY TranslateTable[] =
{
	TRANSLATE_ENTRY(128, "<)"),
	TRANSLATE_ENTRY(129, "x-"),
	TRANSLATE_ENTRY(130, ".V"),
	TRANSLATE_ENTRY(131, "v/"),
	TRANSLATE_ENTRY(132, ".S"),
	TRANSLATE_ENTRY(133, "GS"),
	TRANSLATE_ENTRY(134, "|>"),
	TRANSLATE_ENTRY(135, "pi"),
	TRANSLATE_ENTRY(136, ".d"),
	TRANSLATE_ENTRY(137, "<="),
	TRANSLATE_ENTRY(138, ">="),
	TRANSLATE_ENTRY(139, "=/"),
	TRANSLATE_ENTRY(140, "Ga"),
	TRANSLATE_ENTRY(141, "->"),
	TRANSLATE_ENTRY(142, "<-"),
	TRANSLATE_ENTRY(143, "|v"),
	TRANSLATE_ENTRY(144, "|^"),
	TRANSLATE_ENTRY(145, "Gg"),
	TRANSLATE_ENTRY(146, "Gd"),
	TRANSLATE_ENTRY(147, "Ge"),
	TRANSLATE_ENTRY(148, "Gn"),
	TRANSLATE_ENTRY(149, "Gh"),
	TRANSLATE_ENTRY(150, "Gl"),
	TRANSLATE_ENTRY(151, "Gr"),
	TRANSLATE_ENTRY(152, "Gs"),
	TRANSLATE_ENTRY(153, "Gt"),
	TRANSLATE_ENTRY(154, "Gw"),
	TRANSLATE_ENTRY(155, "GD"),
	TRANSLATE_ENTRY(156, "PI"),
	TRANSLATE_ENTRY(157, "GW"),
	TRANSLATE_ENTRY(158, "[]"),
	TRANSLATE_ENTRY(159, "oo"),
	TRANSLATE_ENTRY(171, "<<"),
	TRANSLATE_ENTRY(176, "^o"),
	TRANSLATE_ENTRY(181, "Gm"),
	TRANSLATE_ENTRY(187, ">>"),
	TRANSLATE_ENTRY(215, ".x"),
	TRANSLATE_ENTRY(216, "O/"),
	TRANSLATE_ENTRY(223, "Gb"),
	TRANSLATE_ENTRY(247, ":-"),
	TRANSLATE_ENTRY(int('\\'), "\\")
};

/////////////////////////////////////////////////////////////////////////////
// CMainFrame construction/destruction

CMainFrame::CMainFrame()
{
	m_pCurrentProject = NULL;
	m_hCancelBuild = CreateEvent(0, FALSE, FALSE, 0);
	m_bBuilding = FALSE;
}

CMainFrame::~CMainFrame()
{
	if (m_pSplashScreenDialog);
		delete m_pSplashScreenDialog;
	if (m_hCancelBuild)
		CloseHandle(m_hCancelBuild);
}

int CMainFrame::OnCreate(LPCREATESTRUCT lpCreateStruct)
{
	if (CMDIFrameWnd::OnCreate(lpCreateStruct) == -1)
		return -1;

	CString Path, FullPath;
	GetModuleFileName(NULL, Path.GetBuffer(MAX_PATH), MAX_PATH);
	Path.ReleaseBuffer();
	
	char * pFilename;
	char * pStart = FullPath.GetBuffer(MAX_PATH);
	GetFullPathName(Path, MAX_PATH, pStart, &pFilename);
	FullPath.ReleaseBuffer();
	Path = FullPath.Left(pFilename - pStart - 1);

	AddProgramSetting("Program Settings:", "", "", PROGRAM_SETTING_INFO::SECTION);
	AddProgramSetting("Registration Name", "RegName", "Non-Commercial User", PROGRAM_SETTING_INFO::STRING);
	AddProgramSetting("Registration Key", "RegKey", "No Key Needed", PROGRAM_SETTING_INFO::STRING);
	AddProgramSetting("Show Tips on Startup", "ShowTips", "Yes", PROGRAM_SETTING_INFO::BOOLEAN);
	AddProgramSetting("Current Tip Number", "TipNum", "0", PROGRAM_SETTING_INFO::INTEGER);
	AddProgramSetting("Transfer COM Port", "COMPort", "2", PROGRAM_SETTING_INFO::INTEGER);
	AddProgramSetting("Baud rate", "BaudRate", "9600", PROGRAM_SETTING_INFO::INTEGER);
	AddProgramSetting("GNUTools Mode", "GNUToolsMode", "No", PROGRAM_SETTING_INFO::BOOLEAN);
	AddProgramSetting("Autodetect GNU/HP", "AutoDetectTools", "Yes", PROGRAM_SETTING_INFO::BOOLEAN);

	AddProgramSetting("Directory Settings:", "", "", PROGRAM_SETTING_INFO::SECTION);
	AddProgramSetting("Default Project Dir.", "DefaultDir", Path + '\\' + "Projects", PROGRAM_SETTING_INFO::STRING);
	AddProgramSetting("Compiled Directory", "CompiledDir", "Compiled", PROGRAM_SETTING_INFO::STRING);
	AddProgramSetting("Output Directory", "OutputDir", "Output", PROGRAM_SETTING_INFO::STRING);
	AddProgramSetting("HP/GNU-Tools Location", "ToolLocation", Path + "\\HPTools", PROGRAM_SETTING_INFO::STRING);
	AddProgramSetting("Template Location", "TemplateLocation", Path + "\\Templates", PROGRAM_SETTING_INFO::STRING);
	AddProgramSetting("EMU48 Location", "EMU48Location", Path + "\\EMU48\\Emu48.exe", PROGRAM_SETTING_INFO::STRING);
	
	AddProgramSetting("Editor Settings:", "", "", PROGRAM_SETTING_INFO::SECTION);
	AddProgramSetting("Tab width [not implemented]", "TabWidth", "2", PROGRAM_SETTING_INFO::INTEGER);
	AddProgramSetting("Smart indent [not implemented]", "SmartIndent", "Yes", PROGRAM_SETTING_INFO::BOOLEAN);
	AddProgramSetting("Template #1 Name", "TemplateName1", "RPL Skeleton", PROGRAM_SETTING_INFO::STRING);
	AddProgramSetting("Template #1 Path", "TemplatePath1", "SysRPL.s", PROGRAM_SETTING_INFO::STRING);
	AddProgramSetting("Template #2 Name", "TemplateName2", "POL Block", PROGRAM_SETTING_INFO::STRING);
	AddProgramSetting("Template #2 Path", "TemplatePath2", "POL.s", PROGRAM_SETTING_INFO::STRING);
	AddProgramSetting("Template #3 Name", "TemplateName3", "Code Block", PROGRAM_SETTING_INFO::STRING);
	AddProgramSetting("Template #3 Path", "TemplatePath3", "CodeBlock.s", PROGRAM_SETTING_INFO::STRING);
	AddProgramSetting("Template #4 Name", "TemplateName4", "(none)", PROGRAM_SETTING_INFO::STRING);
	AddProgramSetting("Template #4 Path", "TemplatePath4", "", PROGRAM_SETTING_INFO::STRING);
	AddProgramSetting("Template #5 Name", "TemplateName5", "(none)", PROGRAM_SETTING_INFO::STRING);
	AddProgramSetting("Template #5 Path", "TemplatePath5", "", PROGRAM_SETTING_INFO::STRING);
	ReadProgramSettings();

	m_pSplashScreenDialog = new CSplashScreenDialog;
	
	CString s;
	AfxFormatString2(s, IDS_REGISTRATION_INFO, GetSettingString("RegName"), GetSettingString("RegKey"));
	
	int RegValue = CheckRegistration(
		GetSettingString("RegName"), 
		GetSettingString("RegKey"));
	if (RegValue == REG_COMMERCIAL)
		s += " (commercial user)";
	if (RegValue == REG_NONCOMMERCIAL)
		s += " (non-commercial user)";
	if (RegValue == REG_INVALID)
		s += " (invalid key)";
	m_pSplashScreenDialog->m_RegInformation = s;

	CCommandLineInfo cmdInfo;
	AfxGetApp()->ParseCommandLine(cmdInfo);
	if (cmdInfo.m_bShowSplash)
		m_pSplashScreenDialog->Create(this);
	
	EnableDocking(CBRS_ALIGN_ANY);

	// Toolbar initialiation
	if (!m_wndMainToolBar.Create(this,
		WS_CHILD | WS_VISIBLE | CBRS_TOP,
		ID_VIEW_TOOLBARS_MAIN) ||
		!m_wndMainToolBar.LoadToolBar(IDR_MAINFRAME))
	{
		TRACE0("Failed to create toolbar\n");
		return -1;      // fail to create
	}
	if (!m_wndProjectToolBar.Create(this,
		WS_CHILD | WS_VISIBLE | CBRS_TOP,
		ID_VIEW_TOOLBARS_PROJECT) ||
		!m_wndProjectToolBar.LoadToolBar(IDR_PROJECTTYPE))
	{
		TRACE0("Failed to create toolbar\n");
		return -1;      // fail to create
	}

	// Status bar initialization
	if (!m_wndStatusBar.Create(this) ||
		!m_wndStatusBar.SetIndicators(indicators,
		  sizeof(indicators)/sizeof(UINT)))
	{
		TRACE0("Failed to create status bar\n");
		return -1;      // fail to create
	}


	// Create droplist on project toolbar
	int nDropHeight = 100, nDropWidth = 150;
	int nButton = m_wndProjectToolBar.GetToolBarCtrl().GetButtonCount() - 2;
	// Design guide advises 12 pixel gap between combos and buttons
	m_wndProjectToolBar.SetButtonInfo(nButton + 1, ID_PROJECT_CURRENTCONFIG, TBBS_SEPARATOR, nDropWidth);
	CRect rect;
	
	m_wndProjectToolBar.GetItemRect(nButton + 1, &rect);
	
	rect.bottom = rect.top + nDropHeight;
	if (!m_CurrentConfig.Create(CBS_DROPDOWNLIST | WS_VISIBLE | WS_TABSTOP,
			rect, &m_wndProjectToolBar, ID_PROJECT_CURRENTCONFIG))
	{
		TRACE0("Failed to create combo-box\n");
		return FALSE;
	}
	m_CurrentConfig.SetFont(&((CHPIDEApp*)AfxGetApp())->m_ComboFont, TRUE);

	m_wndMainToolBar.SetBarStyle(m_wndMainToolBar.GetBarStyle() |
		CBRS_TOOLTIPS | CBRS_FLYBY | CBRS_SIZE_FIXED);
	m_wndProjectToolBar.SetBarStyle(m_wndProjectToolBar.GetBarStyle() |
		CBRS_TOOLTIPS | CBRS_FLYBY | CBRS_SIZE_FIXED);

	m_wndMainToolBar.EnableDocking(CBRS_ALIGN_ANY);
	m_wndProjectToolBar.EnableDocking(CBRS_ALIGN_ANY);
	
	EnableDocking(CBRS_ALIGN_ANY);
	
	DockControlBar(&m_wndMainToolBar);
	DockControlBar(&m_wndProjectToolBar);

	m_wndMainToolBar.SetWindowText("Main");
	m_wndProjectToolBar.SetWindowText("Project");


	// Message dialog bar
	m_pBuildMessageDialog = &m_wndMessageDialogBar;

	// This is a sizeable dialog bar.. that includes gadget resizing
	if (!m_wndMessageDialogBar.Create(this))
	{
		TRACE0("Failed to create dialog bar\n");
		return -1;      
	} 
	m_wndMessageDialogBar.EnableDocking(CBRS_ALIGN_TOP | CBRS_ALIGN_BOTTOM);
	DockControlBar(&m_wndMessageDialogBar, AFX_IDW_DOCKBAR_BOTTOM);	// dock it on the bottom

	CString MissingFiles;
	if (!FileExists(GetSettingString("ToolLocation") + "\\SASM.EXE"))
		MissingFiles += "\nSASM.EXE";
	if (!FileExists(GetSettingString("ToolLocation") + "\\RPLCOMP.EXE"))
		MissingFiles += "\nRPLCOMP.EXE";
	if (!FileExists(GetSettingString("ToolLocation") + "\\SLOAD.EXE"))
		MissingFiles += "\nSLOAD.EXE";
	if (!FileExists(GetSettingString("ToolLocation") + "\\USRLIB.EXE"))
		MissingFiles += "\nUSRLIB.EXE";
	if (!FileExists(GetSettingString("ToolLocation") + "\\USRDIR.EXE"))
		MissingFiles += "\nUSRDIR.EXE";
	if (!FileExists(GetSettingString("ToolLocation") + "\\ENTRIES.O"))
		MissingFiles += "\nENTRIES.O";
	if (MissingFiles != "")
	{
		CString s;
		AfxFormatString2(s, IDS_FILESNOTFOUND, GetSettingString("ToolLocation"), MissingFiles);
		AfxMessageBox(s, MB_OK | MB_ICONERROR);
	}

	if (GetSettingBool("AutoDetectTools"))
	{
		CFile f;
		f.Open(GetSettingString("ToolLocation") + "\\SASM.EXE", CFile::modeRead);
		DWORD dwLen = f.GetLength();
		BOOL bGNUDetected = (dwLen < 140000);
		if (bGNUDetected && !GetSettingBool("GNUToolsMode"))
		{
			if (AfxMessageBox(IDS_FOUNDGNU, MB_YESNO) == IDYES)
				ChangeSetting("GNUToolsMode", "Yes");
				
		}
		if (!bGNUDetected && GetSettingBool("GNUToolsMode"))
		{
			if (AfxMessageBox(IDS_FOUNDHP, MB_YESNO) == IDYES)
				ChangeSetting("GNUToolsMode", "No");
		}
	}
	
	if (RegValue == REG_INVALID)
	{
		AfxMessageBox(IDS_INVALIDREGKEY, MB_OK | MB_ICONERROR);
		CString s;
		s.LoadString(IDS_INVALIDEXPIREDTITLE);
		SetWindowText(s);
	}
	if (RegValue == REG_EXPIRED)
	{
		AfxMessageBox(IDS_EXPIREDREGKEY, MB_OK | MB_ICONERROR);
		CString s;
		s.LoadString(IDS_INVALIDEXPIREDTITLE);
		SetWindowText(s);
	}
	if (RegValue == REG_NONCOMMERCIAL)
	{
		SetWindowText("HP-IDE Non-Commercial Version: NOT FOR COMMERCIAL USE");
	}

	SetLastError(0);
	if (!SetCurrentDirectory(GetSettingString("DefaultDir")))
	{
		if (GetLastError() == 2 || GetLastError() == 3)
			MessageBox(CString("Default project directory doesn't exist: ") + GetSettingString("DefaultDir"));
		else
		{
			CString Error;
			Error.Format("Error %i occurred while changing to default project directory: %s", GetLastError(), GetSettingString("DefaultDir"));
			MessageBox(Error, "Error");
		}
	}

	m_MenuMgr.Install(this);
	m_MenuMgr.LoadToolbar(IDR_MAINFRAME);
	m_MenuMgr.LoadToolbar(IDR_PROJECTTYPE);
	
	return 0;
}

BOOL CMainFrame::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs

	cs.style = WS_OVERLAPPED | WS_CAPTION | FWS_ADDTOTITLE
		| WS_THICKFRAME | WS_SYSMENU | WS_MINIMIZEBOX | WS_MAXIMIZEBOX | WS_MAXIMIZE;

	return CMDIFrameWnd::PreCreateWindow(cs);
}

/////////////////////////////////////////////////////////////////////////////
// CMainFrame diagnostics

#ifdef _DEBUG
void CMainFrame::AssertValid() const
{
	CMDIFrameWnd::AssertValid();
}

void CMainFrame::Dump(CDumpContext& dc) const
{
	CMDIFrameWnd::Dump(dc);
}

#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CMainFrame message handlers

void CMainFrame::OnProjectCloseproject() 
{
	if (AfxGetApp()->SaveAllModified())
	{
		CProjectDocument* pDoc = m_pCurrentProject;
		m_pCurrentProject = NULL;
		pDoc->OnCloseDocument();
		AfxGetApp()->CloseAllDocuments(FALSE);
		m_pBuildMessageDialog->ClearMessages();
		m_pBuildMessageDialog->Hide();
	}
}

void CMainFrame::OnProjectNewproject() 
{
	NewProject();
	GetMainWnd()->UpdateProjectConfigBox();
}

void CMainFrame::OnProjectOpenproject() 
{
	if (m_pCurrentProject)
	{
		MessageBox("Only one project can be open at a time!", "Open Error");
		return;
	}

	CString newName;
	if (!AfxGetApp()->DoPromptFileName(newName, IDS_OPENPROJECT,
	  OFN_HIDEREADONLY | OFN_FILEMUSTEXIST, TRUE, m_pProjectTemplate))
		return; // open cancelled
	m_pCurrentProject = (CProjectDocument*)m_pProjectTemplate->OpenDocumentFile(newName);
}

void CMainFrame::OnProjectSaveproject() 
{
	m_pCurrentProject->OnFileSaveWrapper();
}

void CMainFrame::OnUpdateProjectCloseproject(CCmdUI* pCmdUI) 
{
	pCmdUI->Enable(m_pCurrentProject != NULL);
}

void CMainFrame::OnUpdateProjectNewproject(CCmdUI* pCmdUI) 
{
	pCmdUI->Enable(m_pCurrentProject == NULL);
}

void CMainFrame::OnUpdateProjectOpenproject(CCmdUI* pCmdUI) 
{
	pCmdUI->Enable(m_pCurrentProject == NULL);
}

void CMainFrame::OnUpdateProjectSaveproject(CCmdUI* pCmdUI) 
{
	pCmdUI->Enable(m_pCurrentProject != NULL);
}

void CMainFrame::OnFileNew() 
{
	m_pSourceTemplate->OpenDocumentFile(NULL);
}

void CMainFrame::OnUpdateFileNew(CCmdUI* pCmdUI) 
{
	pCmdUI->Enable(m_pCurrentProject != NULL);
}

void CMainFrame::OnUpdateProjectProjectsettings(CCmdUI* pCmdUI) 
{
	pCmdUI->Enable(m_pCurrentProject != NULL);
}

void CMainFrame::OnProjectProjectsettings() 
{
	CProjectSettingsDialog dlg;
	dlg.m_pProject = m_pCurrentProject;
	if (dlg.DoModal() == IDOK)
	{
		UpdateProjectConfigBox();
		m_pCurrentProject->SetModifiedFlag(TRUE);
		m_pCurrentProject->UpdateListControlFlags();
	}
}

UINT DialogThread(CMainFrame * pFrame)
{
	CBuildInProgressDialog dlg;
	
	dlg.m_hCancelBuild = pFrame->m_hCancelBuild;
	dlg.DoModal();

	return 0;
}	

BOOL CMainFrame::Compile(CString Filename, CBuildProgressDialog * pDlg, BOOL bCheckIfNeeded)
{
	BOOL bSuccess = FALSE;

	CString OrigFilePath, OrigFilename;
	char* pFilename;
	char* pPath = OrigFilePath.GetBuffer(MAX_PATH);
	GetFullPathName(Filename, MAX_PATH, pPath, &pFilename);
	OrigFilename = pFilename;
	OrigFilePath.ReleaseBuffer();
	OrigFilePath = OrigFilePath.Left(pFilename - pPath);
	
	CString ProjectDir;
	if (m_pCurrentProject && !m_pCurrentProject->GetPathName().IsEmpty())
	{
		char* pFilename;
		char* pPath = ProjectDir.GetBuffer(MAX_PATH);
		GetFullPathName(m_pCurrentProject->GetPathName(), MAX_PATH, pPath, &pFilename);
		ProjectDir.ReleaseBuffer();
		ProjectDir = ProjectDir.Left(pFilename - pPath);
	}
	else
	{
		ProjectDir = OrigFilePath;
	}

	CString OldDir;
	GetCurrentDirectory(MAX_PATH, OldDir.GetBuffer(MAX_PATH));
	OldDir.ReleaseBuffer();
	SetCurrentDirectory(ProjectDir);

//	CString LongOutputDir = ProjectDir + GetSettingString("OutputDir");
	CString LongOutputDir = GetSettingString("OutputDir");
	CreateDirectory(LongOutputDir, NULL);
	LongOutputDir += "\\";
	
	CString OutputDir;
	GetShortPathName(LongOutputDir, OutputDir.GetBuffer(MAX_PATH), MAX_PATH);
	OutputDir.ReleaseBuffer();

//	CString LongCompiledOutputDir = ProjectDir + GetSettingString("CompiledDir");
	CString LongCompiledOutputDir = GetSettingString("CompiledDir");
	CreateDirectory(LongCompiledOutputDir, NULL);
	LongCompiledOutputDir += "\\";

	CString NewFilename;
	GetShortPathName(OrigFilePath + OrigFilename, NewFilename.GetBuffer(MAX_PATH), MAX_PATH);
	NewFilename.ReleaseBuffer();

	CString FilePath;
	pPath = FilePath.GetBuffer(MAX_PATH);
	GetFullPathName(NewFilename, MAX_PATH, pPath, &pFilename);
	Filename = pFilename;
	FilePath.ReleaseBuffer();
	FilePath = FilePath.Left(pFilename - pPath);

	if (OrigFilename.Right(2) == (".s"))
		OrigFilename = OrigFilename.Left(OrigFilename.GetLength() - 2);
	if (OrigFilename.Right(2) == (".S"))
		OrigFilename = OrigFilename.Left(OrigFilename.GetLength() - 2);

	if (Filename.Right(2) == (".s"))
		Filename = Filename.Left(Filename.GetLength() - 2);
	if (Filename.Right(2) == (".S"))
		Filename = Filename.Left(Filename.GetLength() - 2);

	CString CapFilename = OrigFilename;
	CapFilename.MakeUpper();
	if (CapFilename.Right(3) == ".GX")
	{
		m_pBuildMessageDialog->AddMessage("Copying binary file " + OrigFilename + ".gx");
		CopyFile(Filename, LongCompiledOutputDir + OrigFilename + ".gx", FALSE);		
		return TRUE;
	}

	if (bCheckIfNeeded)
	{
		if (CheckDependancies(FilePath + Filename + ".s", LongCompiledOutputDir + OrigFilename + ".gx"))
		{
			m_pBuildMessageDialog->AddMessage(OrigFilename + ".gx is up to date");
			return TRUE;
		}
	}

	try
	{
		m_pBuildMessageDialog->Show();
		{
			CString ProgramName = GetSettingString("ToolLocation") + "\\RPLCOMP.EXE";
			CString Parameters = FilePath + Filename + ".s " + OutputDir + Filename  + ".a";
			m_pBuildMessageDialog->AddMessage("Running RPLCOMP.EXE:");
			BOOL bNoErrors = RunProgram(ProgramName, Parameters, ProjectDir, pDlg);
			if (!bCheckIfNeeded)
				pDlg->StepIt();
			if (!bNoErrors)
				return FALSE;
		}

		{
			CString ProgramName = GetSettingString("ToolLocation") + "\\SASM.EXE";
			CString Parameters;
			CString ShortToolDirectory = GetSettingString("ToolLocation");
			GetShortPathName(ShortToolDirectory, ShortToolDirectory.GetBuffer(MAX_PATH), MAX_PATH);
			ShortToolDirectory.ReleaseBuffer();
			if (GetSettingBool("GNUToolsMode"))
			{
				Parameters = "-E -N ";
			}
			else
			{
				Parameters = "-E -t "
					+ ShortToolDirectory + "\\SASM.OPC ";
			}
			Parameters += OutputDir + Filename + ".a";
			m_pBuildMessageDialog->AddMessage("Running SASM.EXE:");
			BOOL bNoErrors = RunProgram(ProgramName, Parameters, ProjectDir, pDlg);
			if (!bCheckIfNeeded)
				pDlg->StepIt();
			if (!bNoErrors)
				return FALSE;
		}

		DeleteFile(LongCompiledOutputDir + OrigFilename + ".gx");
		{
			CString Path;
			GetShortPathName(GetSettingString("ToolLocation"), Path.GetBuffer(MAX_PATH), MAX_PATH);
			Path.ReleaseBuffer();
			m_pBuildMessageDialog->AddMessage(CString("Creating ") + Filename + ".m");
			ofstream outs(OutputDir + Filename + ".m");
			outs << "** The compiled output file" << endl;
			outs << "OU " << OutputDir << Filename << ".gx" << endl;
			outs << "** Our linker listing file" << endl;
			outs << "LL " << OutputDir << Filename << ".lr" << endl;
			outs << "** Suppress all this stuff we don't need" << endl;
			outs << "SU XR SU" << endl;
			outs << "** Search this entries list" << endl;
			outs << "SE " << Path << "\\ENTRIES.O" << endl;
			outs << "** Relocate our object" << endl;
			outs << "RE " << OutputDir << Filename << ".o" << endl;
			outs.close();
			CString ProgramName = GetSettingString("ToolLocation") + "\\SLOAD.EXE";
			CString Parameters = "-H " + OutputDir + Filename + ".m";
			m_pBuildMessageDialog->AddMessage("Running SLOAD.EXE:");

			BOOL bNoErrors = RunProgram(ProgramName, Parameters, ProjectDir, pDlg);
			if (!bCheckIfNeeded)
				pDlg->StepIt();

			DWORD dwRead;
			CString Buffer;
			
			HANDLE LRFile = CreateFile(OutputDir + Filename + ".lr", GENERIC_READ,
				FILE_SHARE_READ, NULL, OPEN_EXISTING, 0, NULL);

			int MessageCount = 0;
			ReadFile(LRFile, Buffer.GetBuffer(10000), 10000, &dwRead, NULL);
			Buffer.ReleaseBuffer(dwRead);
			istrstream ins(Buffer.GetBuffer(dwRead), dwRead);
			while (ins)
			{
				MessageCount++;
				CString t;
				ins.getline(t.GetBuffer(1024), 1024);
				t.ReleaseBuffer();
				t = t.Left(t.GetLength() - 1);
				m_pBuildMessageDialog->AddMessage(t);
			}
			CloseHandle(LRFile);
			if (!bNoErrors)
				return FALSE;
		}
		bSuccess = TRUE;
	}
	catch (char * reason)
	{
		CString Reason = reason;
		if (Reason == "Cancelled")
			m_pBuildMessageDialog->AddMessage("Cancelled!");
	}
	
	if (bSuccess)
	{
		m_pBuildMessageDialog->AddMessage(CString("Successfully built ") + OrigFilename + ".gx");
		MoveFile(OutputDir + Filename + ".gx", LongCompiledOutputDir + OrigFilename + ".gx");
	}

	SetCurrentDirectory(OldDir);

	return bSuccess;
}

void CMainFrame::OnFileSaveall() 
{
	POSITION pos = m_pSourceTemplate->GetFirstDocPosition();
	CDocument* pDoc;
	while (pos)
	{
		pDoc = m_pSourceTemplate->GetNextDoc(pos);
		if (!pDoc->GetPathName().IsEmpty() && pDoc->IsModified())
			pDoc->OnSaveDocument(pDoc->GetPathName());
	}
	if (m_pCurrentProject && m_pCurrentProject->IsModified())
		m_pCurrentProject->OnSaveDocument(m_pCurrentProject->GetPathName());
}

void CMainFrame::OnBuildBuildproject() 
{
	m_bCancelled = FALSE;
	OnFileSaveall();
	CBuildProgressDialog dlg;
	dlg.Create();

	CString ProjectFile = m_pCurrentProject->GetPathName();
	CString ProjectPath;
	char* pFilename;
	char* pPath = ProjectPath.GetBuffer(MAX_PATH);
	GetFullPathName(ProjectFile, MAX_PATH, pPath, &pFilename);
	ProjectPath.ReleaseBuffer();
	ProjectPath = ProjectPath.Left(pFilename - pPath);

	m_pBuildMessageDialog->Show();
	m_pBuildMessageDialog->ClearMessages();
	CString Type = m_pCurrentProject->m_ProjectType;
	m_pBuildMessageDialog->AddMessage("--- Configuration: " + m_pCurrentProject->GetCurrentConfigName() + " ---");
	if (Type == "Library")
	{
		m_pBuildMessageDialog->AddMessage("Building project as library...");
		UpdateVisibleFile("ProjectVisible.s");
		UpdateConfigFile("ProjectConfig.s");
		UpdateTitleFile("ProjectTitle.s");
		OnFileSaveall();
	}
	else if (Type == "Individual")
	{
		m_pBuildMessageDialog->AddMessage("Building project as individual files...");
	}
	else 
	{
		m_pBuildMessageDialog->AddMessage("Building project as directory...");
	}
	BOOL bSuccess = TRUE;
	dlg.SetPos(0);
	dlg.SetRange(0, m_pCurrentProject->m_FileList.GetSize());
	dlg.SetStep(1);
	for (int i = 0; i < m_pCurrentProject->m_FileList.GetSize(); i++)
	{
		CString Filename = m_pCurrentProject->m_FileList[i].Filename;
		if (m_pCurrentProject->FileInCurrentConfig(i))
		{
			CString s;
			AfxFormatString1(s, IDS_COMPILINGFILES, Filename);
			dlg.SetStatus(s);
			if (Filename.Find(":") == -1 && Filename.Find("\\\\") == -1)
			{
				if (!Compile(ProjectPath + Filename, &dlg, TRUE))
					bSuccess = FALSE;
			}
			else
			{
				if (!Compile(Filename, &dlg, TRUE))
					bSuccess = FALSE;
			}
		}
		if (dlg.CheckCancelButton())
		{
			CancelBuild();
			return;
		}
		dlg.StepIt();
	}
	if (bSuccess)
	{
		m_pBuildMessageDialog->AddMessage("Successfully built all files");
		if (Type != "Individual")
		{
			CString s;
			s.LoadString(IDS_CREATINGDIRECTORY);
			dlg.SetStatus(s);
			MakeHPDirectory(m_pCurrentProject->GetBaseName() + ".dir", dlg);
		}
		if (dlg.CheckCancelButton())
		{
			CancelBuild();
			return;
		}
		if (Type == "Library")
		{
			CString s;
			s.LoadString(IDS_CREATINGLIBRARY);
			dlg.SetStatus(s);
			MakeHPLibrary(m_pCurrentProject->GetBaseName(), dlg);
		}
	}
	else
	{
		m_pBuildMessageDialog->AddMessage("There were errors during compile process");
	}
}

void CMainFrame::OnUpdateBuildBuildproject(CCmdUI* pCmdUI) 
{
	pCmdUI->Enable(m_pCurrentProject && !m_pCurrentProject->GetPathName().IsEmpty());
}

BOOL CMainFrame::MakeHPDirectory(CString FileName, CBuildProgressDialog& dlg)
{
	dlg.SetPos(0);
	dlg.SetRange(0, 2);
	dlg.SetStep(1);

	m_pBuildMessageDialog->AddMessage("Building directory...");

	CString ListingFile = m_pCurrentProject->GetProjectDir() + GetSettingString("OutputDir") + "\\" + FileName.Left(FileName.GetLength() - 4) + ".lst";
	CString DirectoryFile = m_pCurrentProject->GetProjectDir() + GetSettingString("CompiledDir") + "\\" + FileName;

	{
		ofstream outs(m_pCurrentProject->GetProjectDir() + GetSettingString("OutputDir") + "\\" + FileName.Left(FileName.GetLength() - 4) + ".lst");
		for (int i = m_pCurrentProject->m_FileList.GetSize() - 1; i >= 0; i--)
		{
			CString Filename = m_pCurrentProject->m_FileList[i].Filename;
			if (m_pCurrentProject->FileInCurrentConfig(i))
			{
				if (Filename.Find(":") == -1 && Filename.Find("\\\\") == -1)
					Filename = m_pCurrentProject->GetProjectDir() + GetSettingString("CompiledDir") + "\\" + Filename;
					
				if (Filename.Right(2) == (".s"))
					Filename = Filename.Left(Filename.GetLength() - 2);
				if (Filename.Right(2) == (".S"))
					Filename = Filename.Left(Filename.GetLength() - 2);
				
				outs << Filename << ".gx;" << m_pCurrentProject->m_FileList[i].HPName << endl;
			}
		}
	}
	dlg.StepIt();

	CString Filename = GetSettingString("ToolLocation") + "\\USRDIR.EXE";
	CString Parameters = "-in \"" + ListingFile + "\" -out \"" + DirectoryFile + "\"";

	BOOL rc = RunProgram(Filename, Parameters, m_pCurrentProject->GetProjectDir(), &dlg);

	dlg.StepIt();

	return rc;
}

void CMainFrame::WriteNibbles(CArray<BYTE, BYTE>& NibbleArray, void * Buffer, int Length)
{
	NibbleArray.SetSize(NibbleArray.GetSize() + Length);
	for (int i = 0; i < Length / 2; i++)
	{
		NibbleArray[m_nNibbleOffset] = (((BYTE*)(Buffer))[i]) & 0x0f;
		NibbleArray[m_nNibbleOffset + 1] = (((BYTE*)(Buffer))[i]) >> 4;
		m_nNibbleOffset += 2;
	}
	if (Length & 1 == 1)
	{
		NibbleArray[m_nNibbleOffset] = (((BYTE*)(Buffer))[Length / 2]) & 0x0f;
		m_nNibbleOffset++;
	}
}

void CMainFrame::WriteNibbleWord(CArray<BYTE, BYTE>& NibbleArray, int nWord, BOOL bUpdateSize)
{
	if (bUpdateSize)
		NibbleArray.SetSize(NibbleArray.GetSize() + 5);
	NibbleArray[m_nNibbleOffset] = (nWord & 0x0000f) >> 0;
	NibbleArray[m_nNibbleOffset+1] = (nWord & 0x000f0) >> 4;
	NibbleArray[m_nNibbleOffset+2] = (nWord & 0x00f00) >> 8;
	NibbleArray[m_nNibbleOffset+3] = (nWord & 0x0f000) >> 12;
	NibbleArray[m_nNibbleOffset+4] = (nWord & 0xf0000) >> 16;
	m_nNibbleOffset += 5;
}

void CMainFrame::UpdateVisibleFile(CString Filename)
{
	CString ProjectDir = m_pCurrentProject->GetProjectDir();

	BOOL bFound = FALSE;
	for (int i = 0; i < m_pCurrentProject->m_FileList.GetSize(); i++)
	{
		if (m_pCurrentProject->m_FileList[i].HPName == "$VISIBLE")
			bFound = TRUE;
	}
	if (!bFound)
	{
		m_pCurrentProject->AddFileToProject(ProjectDir + Filename, "$VISIBLE");
		PROJECT_FILE_INFO Info;
		Info.bVisible = FALSE;
		Info.bCompile = TRUE;
		Info.bInclude = FALSE;
		m_pCurrentProject->SetFileInfo(Filename, Info);
	}
	if (!CheckDependancies(m_pCurrentProject->GetPathName(), ProjectDir + Filename))
	{
		ofstream outs(ProjectDir + Filename);
		CTime CurrentTime = CTime::GetCurrentTime();
		CString TimeString = CurrentTime.Format("%H:%M:%S %A, %B %d, %Y");

		m_pBuildMessageDialog->AddMessage(CString("Writing ") + Filename + " [" + ProjectDir + Filename + "]");
		outs << "* " << Filename << ", generated " << TimeString << endl;
		outs << "* This file is automatically generated each time this project" << endl;
		outs << "* is built as a library.  Any changes made will be lost!" << endl;
		outs << endl;
		outs << "ASSEMBLE" << endl;
		outs << "  NIBASC /HPHP48-R/" << endl;
		outs << "RPL" << endl;
		outs << "* This is our $VISIBLE list (after translation)" << endl;
		outs << "DOLIST" << endl;
		for (int i = 0; i < m_pCurrentProject->m_FileList.GetSize(); i++)
		{
			if (m_pCurrentProject->FileInCurrentConfig(i))
				outs << "  ID " << Translate(m_pCurrentProject->m_FileList[i].HPName) << endl;
		}
		
		outs << "SEMI" << endl;
	}
}

void CMainFrame::UpdateConfigFile(CString Filename)
{
	CString ProjectDir = m_pCurrentProject->GetProjectDir();

	BOOL bFound = FALSE;
	for (int i = 0; i < m_pCurrentProject->m_FileList.GetSize(); i++)
	{
		if (m_pCurrentProject->m_FileList[i].HPName == "$CONFIG")
			bFound = TRUE;
	}
	if (!bFound)
	{
		m_pCurrentProject->AddFileToProject(ProjectDir + Filename, "$CONFIG");
		PROJECT_FILE_INFO Info;
		Info.bVisible = FALSE;
		Info.bCompile = TRUE;
		Info.bInclude = FALSE;
		m_pCurrentProject->SetFileInfo(Filename, Info);
	}
	if (!CheckDependancies(m_pCurrentProject->GetPathName(), ProjectDir + Filename))
	{

		ofstream outs(ProjectDir + Filename);
		CTime CurrentTime = CTime::GetCurrentTime();
		CString TimeString = CurrentTime.Format("%H:%M:%S %A, %B %d, %Y");

		m_pBuildMessageDialog->AddMessage(CString("Writing ") + Filename + " [" + ProjectDir + Filename + "]");
		outs << "* " << Filename << ", generated " << TimeString << endl;
		outs << "* This file is automatically generated each time this project" << endl;
		outs << "* is built as a library.  Any changes made will be lost!" << endl;
		outs << endl;
		outs << "ASSEMBLE" << endl;
		outs << "  NIBASC /HPHP48-R/" << endl;
		outs << "RPL" << endl;
		outs << "::" << endl;
		outs << "* This is our $CONFIG program (attaches to home directory)" << endl;
		outs << "  HOMEDIR" << endl;
		outs << "  " << m_pCurrentProject->m_nROMID << endl;
		outs << "  XEQSETLIB" << endl;
		outs << ";" << endl;
	}
}

void CMainFrame::MakeHPLibrary(CString Filebase, CBuildProgressDialog& dlg)
{
	dlg.SetPos(0);
	dlg.SetRange(0, 1);
	ResetEvent(m_hCancelBuild);

	CString ProjectDir;
	char* pFilename;
	char* pPath = ProjectDir.GetBuffer(MAX_PATH);
	GetFullPathName(m_pCurrentProject->GetPathName(), MAX_PATH, pPath, &pFilename);
	ProjectDir.ReleaseBuffer();
	ProjectDir = ProjectDir.Left(pFilename - pPath);
	
	CString LongOutputDir = ProjectDir + GetSettingString("CompiledDir");
	DeleteFile(LongOutputDir + "\\" + Filebase + ".lib");

	CString InputFile;
	GetShortPathName(LongOutputDir + "\\" + Filebase + ".dir", InputFile.GetBuffer(MAX_PATH), MAX_PATH);
	InputFile.ReleaseBuffer();
	CString InputPath = InputFile;
	GetFullPathName(InputPath, MAX_PATH, InputPath.GetBuffer(MAX_PATH), &pFilename);
	InputPath.ReleaseBuffer();
	InputFile = pFilename;
	CString OutputFile = "$$$$!!!!.LIB";

	CString CommandLine;
	CommandLine.Format("-r %i ", m_pCurrentProject->m_nROMID);
	CommandLine += InputFile + " " + OutputFile;
	if (RunProgram(GetSettingString("ToolLocation") + "\\USRLIB.EXE", CommandLine, m_pCurrentProject->GetProjectDir() + "\\" + GetSettingString("CompiledDir"), &dlg))
	{
		m_pBuildMessageDialog->AddMessage(CString("Successfully built ") + Filebase + ".lib");
		MoveFile(LongOutputDir + "\\" + OutputFile, LongOutputDir + "\\" + Filebase + ".lib");
	}

	dlg.SetPos(1);
	
	SetEvent(m_hCancelBuild);
}

BOOL CMainFrame::CheckDependancies(CString From, CString To)
{
	HANDLE hFind;
	WIN32_FIND_DATA FindData;
	FILETIME ftSource, ftCompiled;
	hFind = FindFirstFile(From, &FindData);
	if (hFind != INVALID_HANDLE_VALUE)
	{
		ftSource = FindData.ftLastWriteTime;
		FindClose(hFind);
		hFind = FindFirstFile(To, &FindData);
		if (hFind != INVALID_HANDLE_VALUE)
		{
			ftCompiled = FindData.ftLastWriteTime;
			FindClose(hFind);
			CTime Source(ftSource), Compiled(ftCompiled);
			if (Compiled > Source)
			{
				return TRUE;
			}
		}
	}
	return FALSE;
}

void CMainFrame::OnViewOptions() 
{
	CProgramSettingsDialog dlg;
	dlg.DoModal();
}

void CMainFrame::AddProgramSetting(CString Name, CString Key, CString Default, PROGRAM_SETTING_INFO::PROGRAM_SETTING_TYPE Type)
{
	PROGRAM_SETTING_INFO Info;
	Info.SettingName = Name;
	Info.SettingKey = Key;
	Info.DefaultValue = Default;
	Info.nType = Type;
	m_ProgramSettingList.Add(Info);
}

void CMainFrame::ReadProgramSettings()
{
	HKEY hMainKey;
	if (RegCreateKey(HKEY_CURRENT_USER, "Software\\HP-IDE\\Options", &hMainKey) == ERROR_SUCCESS)
	{
		for (int i = 0; i < m_ProgramSettingList.GetSize(); i++)
		{
			PROGRAM_SETTING_INFO Info = m_ProgramSettingList[i];
			if (Info.nType != PROGRAM_SETTING_INFO::SECTION)
			{
				HKEY hItemKey;
				BOOL bSuccess = FALSE;
				if (RegOpenKey(hMainKey, Info.SettingKey, &hItemKey) == ERROR_SUCCESS)
				{
					long lSize = 0;
					CString KeyData;
					RegQueryValue(hItemKey, NULL, NULL, &lSize);
					if (RegQueryValue(hItemKey, NULL, KeyData.GetBuffer(lSize), &lSize) == ERROR_SUCCESS)
					{
						KeyData.ReleaseBuffer();
						RegCloseKey(hItemKey);
						m_ProgramSettingList[i].CurrentValue = KeyData;
						bSuccess = TRUE;
					}
				}
				if (!bSuccess)
				{
					m_ProgramSettingList[i].CurrentValue = m_ProgramSettingList[i].DefaultValue;
				}
			}
		}
		RegCloseKey(hMainKey);
	}
}

CString CMainFrame::GetSettingString(CString KeyName)
{
	for (int i = 0; i < m_ProgramSettingList.GetSize(); i++)
	{
		if (m_ProgramSettingList[i].SettingKey == KeyName)
			return m_ProgramSettingList[i].CurrentValue;
	}

	return "";
}

CString CMainFrame::Translate(CString TranslateString)
{
	int nTranslate = sizeof(TranslateTable) / sizeof(TRANSLATE_ENTRY);
	for (int i = 0; i < TranslateString.GetLength(); i++)
	{
		if (TranslateString[i] == '\\')
		{
			for (int j = 0; j < nTranslate; j++)
			{
				if (TranslateString.Mid(i + 1, TranslateTable[j].Code.GetLength()) == TranslateTable[j].Code)
				{
					TranslateString = TranslateString.Left(i) + char(TranslateTable[j].CharNum) 
						+ TranslateString.Mid(i + TranslateTable[j].Code.GetLength() + 1);
					break;
				}
			}
			if (j == nTranslate)
			{
				if (isdigit(TranslateString[i + 1]) &&
					isdigit(TranslateString[i + 2]) &&
					isdigit(TranslateString[i + 3]))
				{
					int nChar = (TranslateString[i + 1] - 48) * 100 +
						(TranslateString[i + 2] - 48) * 10 +
						(TranslateString[i + 3] - 48) * 1;
					if (nChar < 256)
					{
						TranslateString = TranslateString.Left(i) + char(nChar) + TranslateString.Mid(i + 4);
					}
				}
			}
		}
	}
	return TranslateString;
}

void CMainFrame::UpdateTitleFile(CString Filename)
{
	CString ProjectDir = m_pCurrentProject->GetProjectDir();

	BOOL bFound = FALSE;
	for (int i = 0; i < m_pCurrentProject->m_FileList.GetSize(); i++)
	{
		if (m_pCurrentProject->m_FileList[i].HPName == "$TITLE")
			bFound = TRUE;
	}
	if (!bFound)
	{
		m_pCurrentProject->AddFileToProject(ProjectDir + Filename, "$TITLE");
		PROJECT_FILE_INFO Info;
		Info.bVisible = FALSE;
		Info.bCompile = TRUE;
		Info.bInclude = FALSE;
		m_pCurrentProject->SetFileInfo(Filename, Info);
	}
	if (!CheckDependancies(m_pCurrentProject->GetPathName(), ProjectDir + Filename))
	{
		ofstream outs(ProjectDir + Filename);
		CTime CurrentTime = CTime::GetCurrentTime();
		CString TimeString = CurrentTime.Format("%H:%M:%S %A, %B %d, %Y");

		m_pBuildMessageDialog->AddMessage(CString("Writing ") + Filename + " [" + ProjectDir + Filename + "]");
		outs << "* " << Filename << ", generated " << TimeString << endl;
		outs << "* This file is automatically generated each time this project" << endl;
		outs << "* is built as a library.  Any changes made will be lost!" << endl;
		outs << endl;
		outs << "ASSEMBLE" << endl;
		outs << "  NIBASC /HPHP48-R/" << endl;
		outs << "* Our title string, encoded in hex to save special chars" << endl;
		outs << "  CON(5) =DOCSTR" << endl;
		CString Title = Translate(m_pCurrentProject->GetLibraryTitle());
		outs << "  CON(5) " << Title.GetLength() * 2 + 5;
		for (int i = 0; i < Title.GetLength(); i++)
		{
			if (i % 8 == 0)
				outs << endl << "  NIBHEX ";
			char HexChars[] = "0123456789ABCDEF";
			BYTE nChar = (BYTE)Title[i];
			outs << HexChars[nChar & 0x0f] << HexChars[(nChar & 0xf0) >> 4];
		}
		outs << endl;
		outs << "RPL" << endl;
	}
}

BOOL CMainFrame::FileExists(CString Filename)
{
	WIN32_FIND_DATA FindData;
	HANDLE hFind = FindFirstFile(Filename, &FindData);
	if (hFind == INVALID_HANDLE_VALUE)
		return FALSE;

	FindClose(hFind);
	return TRUE;
}

int CMainFrame::GetSettingInt(CString KeyName)
{
	for (int i = 0; i < m_ProgramSettingList.GetSize(); i++)
	{
		if (m_ProgramSettingList[i].SettingKey == KeyName)
			return atoi(m_ProgramSettingList[i].CurrentValue);
	}

	return 0;
}

BOOL CMainFrame::GetSettingBool(CString KeyName)
{
	for (int i = 0; i < m_ProgramSettingList.GetSize(); i++)
	{
		if (m_ProgramSettingList[i].SettingKey == KeyName)
			return (m_ProgramSettingList[i].CurrentValue == "Yes");
	}

	return FALSE;
}

void CMainFrame::ChangeSetting(CString KeyName, CString NewValue)
{
	for (int i = 0; i < m_ProgramSettingList.GetSize(); i++)
	{
		if (m_ProgramSettingList[i].SettingKey == KeyName)
		{
			m_ProgramSettingList[i].CurrentValue = NewValue;
			return;
		}
	}
}

void CMainFrame::WriteSetting(CString KeyName)
{
	int nIndex = -1;
	for (int i = 0; i < m_ProgramSettingList.GetSize(); i++)
	{
		if (m_ProgramSettingList[i].SettingKey == KeyName)
		{
			nIndex = i;
		}
	}
	if (nIndex == -1)
		return;

	HKEY hMainKey;
	if (RegCreateKey(HKEY_CURRENT_USER, "Software\\HP-IDE\\Options", &hMainKey) == ERROR_SUCCESS)
	{
		PROGRAM_SETTING_INFO Info = m_ProgramSettingList[nIndex];
		if (Info.nType != PROGRAM_SETTING_INFO::SECTION)
		{
			HKEY hItemKey;
			if (RegCreateKey(hMainKey, Info.SettingKey, &hItemKey) == ERROR_SUCCESS)
			{
				CString KeyData = Info.CurrentValue;
				RegSetValue(hItemKey, NULL, REG_SZ, KeyData, KeyData.GetLength()) == ERROR_SUCCESS;
				RegCloseKey(hItemKey);
			}
		}
		RegCloseKey(hMainKey);
	}	

}

void CMainFrame::OnHelpTipoftheday() 
{
	CTipDlg dlg;
	dlg.DoModal();
}

void CMainFrame::NewProject()
{
	ASSERT(m_pCurrentProject == NULL);
	m_pCurrentProject = (CProjectDocument*)m_pProjectTemplate->OpenDocumentFile(NULL);
}

BOOL CMainFrame::Transfer(CString Filename, CString HPName /* = "" */)
{
	CTransferInProgressDialog dlg;
	dlg.m_Filename = Filename;
	dlg.m_HPName = Translate(HPName);
	dlg.DoModal();

	return TRUE;
}

void CMainFrame::OnBuildTransferproject() 
{
//	OnBuildBuildproject();
	CString Type = m_pCurrentProject->m_ProjectType;
	if (Type == "Library")
	{
		Transfer(m_pCurrentProject->GetProjectDir() 
			+ GetSettingString("CompiledDir") + "\\" 
			+ m_pCurrentProject->GetBaseName() + ".lib");
	}
	else if (Type == "Individual")
	{
	}
	else 
	{
		Transfer(m_pCurrentProject->GetProjectDir() 
			+ GetSettingString("CompiledDir") + "\\" 
			+ m_pCurrentProject->GetBaseName() + ".dir");
	}
}

void CMainFrame::OnUpdateBuildTransferproject(CCmdUI* pCmdUI) 
{
	pCmdUI->Enable(m_pCurrentProject && !m_pCurrentProject->GetPathName().IsEmpty());
}

void CMainFrame::OnFileTransferfile() 
{
	CFileDialog dlg(TRUE, "*", NULL, 
		OFN_FILEMUSTEXIST | OFN_HIDEREADONLY | OFN_PATHMUSTEXIST |
		OFN_EXPLORER,
		"All files (*.*) | *.*", this);
	if (dlg.DoModal() == IDOK)
		Transfer(dlg.GetPathName());
}

void CMainFrame::OnUpdateBuildCancelbuild(CCmdUI* pCmdUI) 
{
	pCmdUI->Enable(m_bBuilding);	
}

void CMainFrame::OnBuildCancelbuild() 
{
	SetEvent(m_hCancelBuild);	
}

CString CMainFrame::GetHash(CString String)
{
	int Hash = 0x451d;
	for (int i = 0; i < String.GetLength(); i++)
	{
		Hash = ~(Hash + i * 37);
		Hash += String[i] * 23;
		Hash ^= String[i] * 11;
		Hash -= i * 3;
	}
	Hash ^= String.GetLength() * 0x1123;
	Hash &= 0xffff;
	CString HashString;
	HashString.Format("%04X", Hash);
	return HashString;
}

CString CMainFrame::Encrypt(CString String)
{
	CString HexChars = "0123456789ABCDEF";
#define unhex(x) (HexChars.Find(x))
#define hex(x)	 (HexChars[x])
	for (int i = 0; i < String.GetLength() - 1; i++)
	{
		for (int j = i + 1; j < String.GetLength(); j++)
		{
			String.SetAt(j, hex( (unhex(String[j]) ^ (unhex(String[i] + i * 2 - j * 3))) & 0xf ));
		}
	}
	String.SetAt(0, hex( 15 - unhex(String[0]) ));
	return String;
}

CString CMainFrame::Decrypt(CString String)
{
	CString HexChars = "0123456789ABCDEF";
#define unhex(x) (HexChars.Find(x))
#define hex(x)	 (HexChars[x])
	String.SetAt(0, hex( 15 - unhex(String[0]) ));
	for (int i = String.GetLength() - 1; i >= 0; i--)
	{
		for (int j = i + 1; j < String.GetLength(); j++)
		{
			String.SetAt(j, hex( (unhex(String[j]) ^ (unhex(String[i] + i * 2 - j * 3))) & 0xf ));
		}
	}

	return String;
}

RegType CMainFrame::CheckRegistration(CString Name, CString Key)
{
	if (Name == "Non-Commercial User" && Key == "No Key Needed")
		return REG_NONCOMMERCIAL;

	CString HexChars = "0123456789ABCDEF";
#define unhex(x) (HexChars.Find(x))

	char KeyClass = Key[0];
	switch (KeyClass)
	{
	case '1':
		{
			if (Key[9] != '-')
				return REG_INVALID;
			if (GetHash(Key.Mid(1, 8)) != Key.Mid(10, 4))
				return REG_INVALID;
			Key = Decrypt(Key.Mid(1, 8));
			if (GetHash(Name) != Key.Mid(2, 4))
				return REG_INVALID;
			if (GetHash(Key.Mid(2, 6)).Right(2) != Key.Left(2))
				return REG_INVALID;
			if (unhex(Key[6]) < 1)
				return REG_EXPIRED;
			if (Key[7] == '1')
				return REG_NONCOMMERCIAL;
			if (Key[7] == '2')
				return REG_COMMERCIAL;
		}
	}
	return REG_INVALID;
}


void CMainFrame::OnUpdateProjectAddfilefromdisk(CCmdUI* pCmdUI) 
{
	pCmdUI->Enable(m_pCurrentProject != NULL);	
}

void CMainFrame::OnProjectAddfilefromdisk() 
{
	if (m_pCurrentProject->GetPathName().IsEmpty())
	{
		AfxMessageBox(IDS_ADDINGTOUNSAVEDPROJECT);
		return;
	}
	CFileDialog dlg(TRUE, "*", NULL, 
		OFN_FILEMUSTEXIST | OFN_HIDEREADONLY | OFN_PATHMUSTEXIST |
		OFN_EXPLORER | OFN_ALLOWMULTISELECT,
		"All source file (*.h;*.s) | *.h; *.s", this);
	if (dlg.DoModal() == IDOK)
	{
		POSITION pos = dlg.GetStartPosition();
		while (pos)
		{
			CString Filename = dlg.GetNextPathName(pos);
			m_pCurrentProject->AddFileToProject(Filename);
		}
	}
}

void CMainFrame::OnUpdateProjectCurrentconfig(CCmdUI* pCmdUI) 
{
	if (m_pCurrentProject == NULL)
	{
		pCmdUI->Enable(FALSE);
		if (m_CurrentConfig.GetCount() != 0)
			m_CurrentConfig.ResetContent();
	}
	else
	{
		pCmdUI->Enable(TRUE);	
	}
}

void CMainFrame::UpdateProjectConfigBox()
{
	if (m_pCurrentProject == NULL)
		return;
	m_CurrentConfig.ResetContent();
	for (int i = 0; i < m_pCurrentProject->m_ProjectConfigList.GetSize(); i++)
	{
		m_CurrentConfig.InsertString(-1, 
			m_pCurrentProject->m_ProjectConfigList[i].ConfigName 
			+ " (" + m_pCurrentProject->m_ProjectConfigList[i].BaseFilename 
			+ ")");
	}
	m_CurrentConfig.SetCurSel(m_pCurrentProject->GetCurrentConfig());
}

void CMainFrame::OnSelchangeCurrentConfig()
{
	if (m_pCurrentProject != NULL)
	{
		int nOldIndex = m_pCurrentProject->m_nCurrentConfig;
		m_pCurrentProject->m_nCurrentConfig = m_CurrentConfig.GetCurSel();
		if (nOldIndex != m_pCurrentProject->m_nCurrentConfig)
		{
			m_pCurrentProject->SetModifiedFlag(TRUE);
			m_pCurrentProject->UpdateListControlFlags();
		}
	}
}

void CMainFrame::OnUpdateBuildSimulateproject(CCmdUI* pCmdUI) 
{
	pCmdUI->Enable(m_pCurrentProject 
		&& !m_pCurrentProject->GetPathName().IsEmpty()
		&& m_pCurrentProject->m_ProjectType != "Individual");
}

void CMainFrame::OnBuildSimulateproject() 
{
	CString ProjectName;
	CString Type = m_pCurrentProject->m_ProjectType;
	
	if (Type == "Library")
	{
		ProjectName = m_pCurrentProject->GetProjectDir() 
			+ GetSettingString("CompiledDir") + "\\" 
			+ m_pCurrentProject->GetBaseName() + ".lib";
	}
	else if (Type == "Directory")
	{
		ProjectName = m_pCurrentProject->GetProjectDir() 
			+ GetSettingString("CompiledDir") + "\\" 
			+ m_pCurrentProject->GetBaseName() + ".dir";
	}

	if (!ProjectName.IsEmpty())
	{
		Simulate(ProjectName);
	}
}

BOOL CMainFrame::Simulate(CString Filename)
{
	OFSTRUCT of;		
	HFILE hFile = OpenFile(Filename, &of, OF_EXIST);
	if (hFile == HFILE_ERROR)
	{
		AfxMessageBox(IDS_PROJECTNOTBUILT, MB_OK | MB_ICONERROR);
		return FALSE;
	}
	CWnd * pWnd = NULL;
	do
	{
		pWnd = FindWindow("CEmu48", NULL);
		if (pWnd == NULL)
		{
			STARTUPINFO si;
			GetStartupInfo(&si);
			PROCESS_INFORMATION pi;
			if (!CreateProcess(GetSettingString("EMU48Location"),
				_T(""),
				NULL, NULL,
				FALSE,
				0, NULL, NULL,
				&si, &pi
				))
			{
				CString s1, s2;
				s1.Format("error #%08x", GetLastError());
				AfxFormatString1(s2, IDS_EMU48ERROR, s1);
				AfxMessageBox(s2, MB_OK | MB_ICONERROR);
				return FALSE;
			}			
			if (AfxMessageBox(IDS_EMU48NOTFOUND, MB_OKCANCEL) == IDCANCEL)
				return FALSE;
		}
	} 
	while (pWnd == NULL);

	HWND hWnd = pWnd->m_hWnd;
	int nLength = Filename.GetLength() + 1;
	HANDLE hMap = CreateFileMapping((HANDLE)0xFFFFFFFF, 
		NULL, PAGE_READWRITE, 0, nLength, 
		"HP-IDE_EMU48_NameTransferBuffer");
	if (hMap != NULL)
	{
		char * pName = (char*)MapViewOfFile(hMap, FILE_MAP_WRITE, 0, 0, nLength);
		if (pName != NULL)
		{
			CopyMemory(pName, Filename, nLength);
			int nResult = pWnd->SendMessage(WM_USER, nLength, 0);
			if (nResult != 0x87654321 && nResult != 0x12345678)
			{
				AfxMessageBox(IDS_EMU48WRONGVERSION);
			}
			::SetForegroundWindow(hWnd);
			UnmapViewOfFile(pName);
		}
		CloseHandle(hMap);
	}

	return TRUE;
}

void CMainFrame::OnEditTemplatesEdit() 
{
	CEditTemplateDialog dlg;
	dlg.DoModal();
}

void CMainFrame::CancelBuild()
{
	m_pBuildMessageDialog->AddMessage("The compile process was cancelled");
}

BOOL CMainFrame::RunProgram(CString Filename, CString Parameters, CString Directory, CBuildProgressDialog * pDlg)
{
	ResetEvent(m_hCancelBuild);

	m_pBuildMessageDialog->AddMessage("[" + Filename + " " + Parameters + "]");
	const int CANCEL_INTERVAL = 100;

	BOOL bResult = TRUE;

	HANDLE hPipeInput = 0, hPipeOutput = 0;
	BOOL rc = CreatePipe(&hPipeInput, &hPipeOutput, NULL, 10000);
	int nError = GetLastError();

	const char *NewEnv[] = 
	{
		NULL
	};
	STARTUPINFO StartupInfo = 
	{
		sizeof(STARTUPINFO),
		NULL, NULL, NULL,
		0, 0, 0, 0, 0, 0, 7,
		STARTF_USESTDHANDLES | STARTF_USESHOWWINDOW,
		SW_HIDE,
		0, NULL, 0, hPipeOutput, hPipeOutput 
	};
	PROCESS_INFORMATION ProcessInfo;

	CString ShortFilename;
	GetShortPathName(Filename, ShortFilename.GetBuffer(MAX_PATH), MAX_PATH);
	ShortFilename.ReleaseBuffer();
	Parameters = "\"" + ShortFilename + "\" " + Parameters;

	rc = CreateProcess(ShortFilename, Parameters.GetBuffer(Parameters.GetLength()),
		NULL, NULL,
		TRUE, CREATE_NEW_CONSOLE,
		NewEnv,
		Directory,
		&StartupInfo,
		&ProcessInfo);
	Parameters.ReleaseBuffer();

	HANDLE hWaitHandles[] = { ProcessInfo.hProcess, m_hCancelBuild };

	if (!rc)
	{
		bResult = FALSE;

		int nError = GetLastError();
		CString Error;
		Error.Format("Error %i executing command line: %s %s", nError, Filename, Parameters);
		m_pBuildMessageDialog->AddMessage(Error);
	}
	else
	{
		while (WaitForMultipleObjects(2, hWaitHandles, FALSE, CANCEL_INTERVAL) == WAIT_TIMEOUT)		
		{
			if (pDlg->CheckCancelButton())
			{
				TerminateProcess(ProcessInfo.hProcess, 0);
				bResult = FALSE;
				m_pBuildMessageDialog->AddMessage("Execution cancelled");
			}
//			DrainPipe(hPipeInput);
		}
		DrainPipe(hPipeInput);

		DWORD dwRet;
		GetExitCodeProcess(ProcessInfo.hProcess, &dwRet);

		BOOL bErrors = (dwRet != 0);
		
		if (bErrors && bResult)
		{
			bResult = FALSE;
			m_pBuildMessageDialog->AddMessage("Error(s) encountered during execution");
		}
		else
		{
			m_pBuildMessageDialog->AddMessage("No Errors");
		}
	}

	CloseHandle(hPipeInput);
	CloseHandle(hPipeOutput);

	SetEvent(m_hCancelBuild);

	return bResult;
}

void CMainFrame::DrainPipe(HANDLE hPipe)
{
	DWORD dwLeft, dwRead;
	BOOL rc = PeekNamedPipe(hPipe, NULL, 0, NULL, &dwLeft, NULL);
	int nError = GetLastError();

	CString Buffer;
	if (dwLeft > 0)
	{
		ReadFile(hPipe, Buffer.GetBuffer(10000), 10000, &dwRead, NULL);
		Buffer.ReleaseBuffer(dwRead);
		istrstream ins(Buffer.GetBuffer(dwRead), dwRead);
		while (ins)
		{
			CString t;
			ins.getline(t.GetBuffer(1024), 1024);
			t.ReleaseBuffer();
			t = t.Left(t.GetLength() - 1);
			m_pBuildMessageDialog->AddMessage(t);
		}
	}
}
