// BuildMessageDialog.cpp : implementation file
//

#include "stdafx.h"
#include "HPIDE.h"
#include "BuildMessageDialog.h"
#include "SourceEditView.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CBuildMessageDialog dialog


CBuildMessageDialog::CBuildMessageDialog(CWnd* pParent /*=NULL*/)
	: CMRCSizeControlBar(SZBARF_STDMOUSECLICKS | SZBARF_ALLOW_MDI_FLOAT) 
{
	m_bVisible = FALSE;
	//{{AFX_DATA_INIT(CBuildMessageDialog)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
}

BEGIN_MESSAGE_MAP(CBuildMessageDialog, CMRCSizeControlBar)
	//{{AFX_MSG_MAP(CBuildMessageDialog)
	ON_WM_DESTROY()
	ON_WM_CLOSE()
	ON_WM_LBUTTONDBLCLK()
	ON_WM_KEYDOWN()
	ON_WM_CREATE()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CBuildMessageDialog message handlers

int CBuildMessageDialog::OnCreate(LPCREATESTRUCT lpCreateStruct)
{
	if (CMRCSizeControlBar::OnCreate(lpCreateStruct) == -1)
		return -1;

	CRect rect;
	GetClientRect(&rect);
		
	// Register a class for the list box without CS_VREDRAW, CS_HREDRAW
	WNDCLASS wc;
	VERIFY(GetClassInfo(AfxGetInstanceHandle(), _T("LISTBOX"), &wc)); 	
	wc.style &= ~(CS_VREDRAW | CS_HREDRAW);
	wc.lpszClassName = "_MF_LISTBOX";
	VERIFY(AfxRegisterClass(&wc));

	if (!m_MessageList.CreateEx(WS_EX_CLIENTEDGE,
                 			_T("_MF_LISTBOX"),
                 			NULL,
     						WS_CHILD | WS_VISIBLE | WS_HSCROLL | WS_VSCROLL
	 								| LBS_HASSTRINGS | LBS_NOTIFY | LBS_NOINTEGRALHEIGHT, 
	             			rect.left,
                 			rect.top,
      						rect.Width(),
							rect.Height(),
                 			GetSafeHwnd(),
                 			0,
                 			NULL))
	{
		TRACE("Failed to create list box\n");
		return -1;
	}

	m_MessageList.SetFont(&((CHPIDEApp*)AfxGetApp())->m_SourceFont);
	
	return 0;
}

void CBuildMessageDialog::OnDestroy() 
{
	CMRCSizeControlBar::OnDestroy();
	
	m_bVisible = FALSE;
}

void CBuildMessageDialog::OnSizedOrDocked(int cx, int cy, BOOL bFloating, int flags)
{
	CRect rect(0, 0, cx, cy);		// rectangle for client area
	
	BOOL bHorz = (m_dwStyle & CBRS_ORIENT_HORZ) != 0;
	
	// shrink rectangle if we're docked
	if (IsProbablyFloating())
		rect.InflateRect(-2, -2);		// shrink for border when floating
	else
		rect.InflateRect(-4, -4);

	// fill the rest of the window with the list box..
	m_MessageList.MoveWindow(&rect);

//	CMRCSizeDialogBar::OnSizedOrDocked(cx, cy, bFloating, flags);
}

void CBuildMessageDialog::Show()
{
	m_MessageList.SetHorizontalExtent(1024);
	GetMainWnd()->ShowControlBar(this, TRUE, FALSE);
	m_bVisible = TRUE;
}

void CBuildMessageDialog::Hide()
{
	GetMainWnd()->ShowControlBar(this, FALSE, FALSE);
	m_bVisible = FALSE;
}

void CBuildMessageDialog::Shrink()
{
/*	ShowWindow(SW_MINIMIZE);
	m_bVisible = FALSE;*/
}

void CBuildMessageDialog::OnClose() 
{
/*	Hide();
	m_bVisible = FALSE;*/
}

BOOL CBuildMessageDialog::OnCommand(WPARAM wParam, LPARAM lParam) 
{
/*	// TODO: Add your specialized code here and/or call the base class
	if (wParam == 2)
	{
		//Hide();
		return TRUE;
	}*/
	return CMRCSizeControlBar::OnCommand(wParam, lParam);
}

void CBuildMessageDialog::OnLButtonDblClk(UINT nFlags, CPoint point) 
{
	CMRCSizeControlBar::OnLButtonDblClk(nFlags, point);
}

/////////////////////////////////////////////////////////////////////////////
// CBuildMessageListBox

CBuildMessageListBox::CBuildMessageListBox()
{
}

CBuildMessageListBox::~CBuildMessageListBox()
{
}


BEGIN_MESSAGE_MAP(CBuildMessageListBox, CListBox)
	//{{AFX_MSG_MAP(CBuildMessageListBox)
	ON_WM_LBUTTONDBLCLK()
	ON_WM_RBUTTONDOWN()
	ON_COMMAND(ID_MESSAGE_CLEARMESSAGES, OnMessageClearmessages)
	ON_COMMAND(ID_MESSAGE_GOTOSOURCE, OnMessageGotosource)
	ON_COMMAND(ID_MESSAGE_JUMPTOEND, OnMessageJumptoend)
	ON_COMMAND(ID_MESSAGE_JUMPTOSTART, OnMessageJumptostart)
	ON_COMMAND(ID_MESSAGE_COPYTOCLIPBOARD, OnMessageCopytoclipboard)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CBuildMessageListBox message handlers

void CBuildMessageListBox::OnLButtonDblClk(UINT nFlags, CPoint point) 
{
	CListBox::OnLButtonDblClk(nFlags, point);
	JumpToLine();
}

void CBuildMessageListBox::OnRButtonDown(UINT nFlags, CPoint point) 
{
	BOOL bOutside;
	int nItem = ItemFromPoint(point, bOutside);
	if (!bOutside)
		SetCurSel(nItem);
	CMenu menu;
	VERIFY(menu.LoadMenu(IDR_MESSAGE_POPUP));
	CMenu* pPopup = menu.GetSubMenu(0);
	ASSERT(pPopup != NULL);
	ClientToScreen(&point);
	pPopup->TrackPopupMenu(TPM_LEFTALIGN | TPM_RIGHTBUTTON, point.x, point.y, this);
}

void CBuildMessageListBox::OnMessageClearmessages() 
{
	ResetContent();
}

void CBuildMessageListBox::JumpToLine()
{
	if (GetCurSel() == LB_ERR)
		return;
	CString Message;
	GetText(GetCurSel(), Message);
	if (Message.Find(": ") == -1)
		return;
	CString Filename, SourceLine;
	if (Message.Left(13) == "*** ERROR in ")
	{
		// GNUTools SASM
		Message = Message.Mid(14);
		Filename = Message.Left(Message.Find('\"'));
		Message = Message.Mid(Message.Find(" on line ") + 9);
		SourceLine = Message.Left(Message.Find(":"));
	}
	else
	{
		if (Message.Find(", ") == -1 || Message.Find(", ") > Message.Find(": "))
		{
			// RPLCOMP
			Filename = Message.Left(Message.Find(": "));
			Message = Message.Right(Message.GetLength() - Message.Find(": ") - 2);
			SourceLine = Message.Left(Message.Find(":"));
		}
		else
		{
			// SASM
			Filename = Message.Left(Message.Find(", "));
			Filename = Filename.Mid(1, Filename.GetLength() - 2);
			Message = Message.Right(Message.GetLength() - Message.Find(", line ") - 7);
			SourceLine = Message.Left(Message.Find(":"));
		}
	}
	// Get LFN version of filename
	Filename.MakeUpper();
	WIN32_FIND_DATA FindData;
	HANDLE hFind = FindFirstFile(Filename, &FindData);
	
	ASSERT(hFind != INVALID_HANDLE_VALUE);
	if (hFind == INVALID_HANDLE_VALUE)
	{
		CString Message;	// For debugging!
		GetText(GetCurSel(), Message);
		return;
	}

	FindClose(hFind);

	CString FilePath;
	char* pFilename;
	char* pPath = FilePath.GetBuffer(MAX_PATH);
	GetFullPathName(Filename, MAX_PATH, pPath, &pFilename);
	FilePath.ReleaseBuffer();
	FilePath = FilePath.Left(pFilename - pPath);
	
	Filename = FilePath + FindData.cFileName;

	int nSourceLine = atoi(SourceLine);
	if (nSourceLine == 0)
		return;
	CDocument* pDocument = AfxGetApp()->OpenDocumentFile(Filename);
	POSITION pos = pDocument->GetFirstViewPosition();
	CView* pView = pDocument->GetNextView(pos);
	((CSourceEditView*)pView)->SetErrorLine(nSourceLine);

	pView->ShowWindow(SW_RESTORE);
	pView->SetFocus();
	m_pParent->Shrink();
}

void CBuildMessageListBox::OnMessageGotosource() 
{
	JumpToLine();	
}

void CBuildMessageListBox::OnMessageCopytoclipboard() 
{
	if (!OpenClipboard())
	{
		AfxMessageBox(IDS_COULDNTOPENCLIPBOARD);
		return;
	}

	EmptyClipboard();

	CString MessageList = "Build Messages:\r\n";

	for (int i = 0; i < GetCount(); i++)
	{
		CString MessageLine;
		GetText(i, MessageLine);
		MessageList += MessageLine + "\r\n";
	}

	HANDLE hMem = GlobalAlloc(GPTR, MessageList.GetLength() + 1);
	CopyMemory(hMem, MessageList, MessageList.GetLength() + 1);
	SetClipboardData(CF_TEXT, hMem);

	CloseClipboard();
}

void CBuildMessageDialog::ClearMessages()
{
	m_MessageList.OnMessageClearmessages();
}

void CBuildMessageListBox::OnMessageJumptoend() 
{
	SetCurSel(GetCount() - 1);
}

void CBuildMessageListBox::OnMessageJumptostart() 
{
	SetCurSel(0);
}

void CBuildMessageDialog::AddMessage(CString Message)
{
	m_MessageList.InsertString(-1, Message);
	m_MessageList.SetCurSel(m_MessageList.GetCount() - 1);
	UpdateWindow();
}

void CBuildMessageDialog::OnKeyDown(UINT nChar, UINT nRepCnt, UINT nFlags) 
{
	if (nChar == 'M' && (nFlags & (1 << 13)))
		Hide();
	CMRCSizeControlBar::OnKeyDown(nChar, nRepCnt, nFlags);
}

BOOL CBuildMessageDialog::Create(CWnd * pParentWnd) 
{
	// register a window class for the control bar
	static CString strWndClass;
	if (strWndClass.IsEmpty())
	{
		strWndClass = AfxRegisterWndClass(CS_DBLCLKS);
	}
	
	return CMRCSizeControlBar::Create(strWndClass,
									   "Build Messages",
									   WS_VISIBLE | WS_CHILD | CBRS_TOP | WS_CLIPCHILDREN,
									   CFrameWnd::rectDefault,
									   pParentWnd, ID_VIEW_MESSAGES);
}

