// ProjectDocument.h : header file
//

#pragma once

/////////////////////////////////////////////////////////////////////////////
// CProjectDocument document

struct PROJECT_FILE_INFO
{
	CString Filename;
	BOOL bVisible;
	BOOL bCompile;
	CString HPName;
	BOOL bInclude;		// TRUE: list of projects to include in
	CString ConfigList;
};

struct PROJECT_CONFIG_INFO
{
	CString ConfigName;
	CString BaseFilename;
	CString LibraryTitle;
};

class CProjectDocument : public CDocument
{
protected:
	CProjectDocument();           // protected constructor used by dynamic creation
	DECLARE_DYNCREATE(CProjectDocument)

// Attributes
public:
	BOOL FileInCurrentConfig(int nIndex);
	void UpdateListControlItem(int nIndex);
	int m_nCurrentConfig;
	CString GetCurrentConfigName();
	int GetCurrentConfig();
	CString GetLibraryTitle();
	CString GetBaseName();
	CArray <PROJECT_CONFIG_INFO, PROJECT_CONFIG_INFO> m_ProjectConfigList;
	void MoveItem(int OldIndex, int NewIndex);
	CString GetProjectDir();
	int m_nROMID;
	CString m_ProjectDirectory;
	BOOL GetSelectedFileState(BOOL& bVisible, BOOL& bCompile);
	BOOL GetFileInfo(CString Filename, PROJECT_FILE_INFO& Info);
	BOOL SetFileInfo(CString Filename, PROJECT_FILE_INFO& Info);
	BOOL FileInProject(CString Filename);
	BOOL AddFileToProject(CString Filename, CString HPName = "");
	void OnFileSaveWrapper();
	CString m_ProjectType;
	void UpdateListControlFlags();
	void UpdateListControl();
	CArray<PROJECT_FILE_INFO, PROJECT_FILE_INFO> m_FileList;

// Operations
public:

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CProjectDocument)
	public:
	virtual void Serialize(CArchive& ar);   // overridden for document i/o
	virtual BOOL CanCloseFrame(CFrameWnd* pFrame);
	virtual BOOL OnOpenDocument(LPCTSTR lpszPathName);
	protected:
	virtual BOOL OnNewDocument();
	//}}AFX_VIRTUAL

// Implementation
public:
	virtual ~CProjectDocument();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

	// Generated message map functions
protected:
	//{{AFX_MSG(CProjectDocument)
	afx_msg void OnUpdateFileClose(CCmdUI* pCmdUI);
	afx_msg void OnProjectTogglecompile();
	afx_msg void OnUpdateProjectTogglecompile(CCmdUI* pCmdUI);
	afx_msg void OnProjectTogglefilevisibility();
	afx_msg void OnUpdateProjectTogglefilevisibility(CCmdUI* pCmdUI);
	afx_msg void OnUpdateFileSaveAs(CCmdUI* pCmdUI);
	afx_msg void OnUpdateProjectEditfilesettings(CCmdUI* pCmdUI);
	afx_msg void OnProjectEditfilesettings();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};
