// ProjectSettingsDialog.cpp : implementation file
//

#include "stdafx.h"
#include "HPIDE.h"
#include "ProjectSettingsDialog.h"
#include <string.h>

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CProjectSettingsDialog dialog


CProjectSettingsDialog::CProjectSettingsDialog(CWnd* pParent /*=NULL*/)
	: CDialog(CProjectSettingsDialog::IDD, pParent)
{
	//{{AFX_DATA_INIT(CProjectSettingsDialog)
	m_Filename = _T("");
	m_Directory = _T("");
	m_CompiledName = _T("");
	m_nProjectType = 0;
	m_nROMID = 0;
	m_LibraryTitle = _T("");
	//}}AFX_DATA_INIT
	bReady = FALSE;
}

CProjectSettingsDialog::~CProjectSettingsDialog()
{
	while (!m_ProjectConfigList.IsEmpty())
	{
		PROJECT_CONFIG_INFO * pInfo = m_ProjectConfigList.RemoveHead();
		delete pInfo;
	}
}

void CProjectSettingsDialog::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CProjectSettingsDialog)
	DDX_Control(pDX, IDC_SETTINGS_CONFIGURATIONLIST, m_ConfigList);
	DDX_Text(pDX, IDC_SETTINGS_PROJECTFILENAME, m_Filename);
	DDX_Text(pDX, IDC_SETTINGS_PROJECTDIRECTORY, m_Directory);
	DDX_Text(pDX, IDC_SETTINGS_COMPILEDNAME, m_CompiledName);
	DDX_CBIndex(pDX, IDC_SETTINGS_PROJECTTYPE, m_nProjectType);
	DDX_Text(pDX, IDC_SETTINGS_PROJECTROMID, m_nROMID);
	DDX_Text(pDX, IDC_SETTINGS_DESCRIPTION, m_LibraryTitle);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CProjectSettingsDialog, CDialog)
	//{{AFX_MSG_MAP(CProjectSettingsDialog)
	ON_BN_CLICKED(IDOK, OnOk)
	ON_NOTIFY(LVN_ITEMCHANGED, IDC_SETTINGS_CONFIGURATIONLIST, OnItemchangedSettingsConfigurationlist)
	ON_NOTIFY(NM_DBLCLK, IDC_SETTINGS_CONFIGURATIONLIST, OnDblclkSettingsConfigurationlist)
	ON_NOTIFY(LVN_ENDLABELEDIT, IDC_SETTINGS_CONFIGURATIONLIST, OnEndlabeleditSettingsConfigurationlist)
	ON_NOTIFY(LVN_BEGINLABELEDIT, IDC_SETTINGS_CONFIGURATIONLIST, OnBeginlabeleditSettingsConfigurationlist)
	ON_BN_CLICKED(IDC_SETTINGS_DIRECTORY, OnSettingsDirectory)
	ON_BN_CLICKED(IDC_SETTINGS_LIBRARY, OnSettingsLibrary)
	ON_BN_CLICKED(IDC_SETTINGS_INDIVIDUALFILES, OnSettingsIndividualfiles)
	ON_EN_CHANGE(IDC_SETTINGS_PROJECTFILENAME, OnChangeSettingsProjectfilename)
	ON_CBN_SELCHANGE(IDC_SETTINGS_PROJECTTYPE, OnSelchangeSettingsProjecttype)
	ON_BN_CLICKED(IDC_SETTINGS_ADDCONFIG, OnSettingsAddconfig)
	ON_WM_CLOSE()
	ON_NOTIFY(LVN_KEYDOWN, IDC_SETTINGS_CONFIGURATIONLIST, OnKeydownSettingsConfigurationlist)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CProjectSettingsDialog message handlers

BOOL CProjectSettingsDialog::OnInitDialog() 
{
	CDialog::OnInitDialog();
	bReady = FALSE;
	m_OriginalConfig = m_pProject->GetCurrentConfigName();
	m_ProjectType = m_pProject->m_ProjectType;
	m_Directory = m_pProject->m_ProjectDirectory;
	m_nROMID = m_pProject->m_nROMID;
/*	if (m_ProjectType == "Library")
		((CButton*)(GetDlgItem(IDC_SETTINGS_LIBRARY)))->SetCheck(TRUE);
	else if (m_ProjectType == "Individual")
		((CButton*)(GetDlgItem(IDC_SETTINGS_INDIVIDUALFILES)))->SetCheck(TRUE);
	else 
		((CButton*)(GetDlgItem(IDC_SETTINGS_DIRECTORY)))->SetCheck(TRUE);
*/
	if (m_ProjectType == "Library")
		m_nProjectType = 2;
	else if (m_ProjectType == "Individual")
		m_nProjectType = 1;
	else 
		m_nProjectType = 0;

	CRect r;
	int nWidth = ::GetSystemMetrics(SM_CXVSCROLL);
	m_ConfigList.GetClientRect(&r);
	m_ConfigList.InsertColumn(0, "name", LVCFMT_LEFT, r.Width() - nWidth);
	m_nCurrentConfig = -1;
	
	for (int i = 0; i < m_pProject->m_ProjectConfigList.GetSize(); i++)
	{
		PROJECT_CONFIG_INFO * pInfo = new PROJECT_CONFIG_INFO;
		*pInfo = m_pProject->m_ProjectConfigList[i];
		CString s;
		s.LoadString(IDS_DEFAULTCONFIG);
		int nIndex = m_ConfigList.InsertItem(0, m_pProject->m_ProjectConfigList[i].ConfigName);
		if (nIndex <= m_nCurrentConfig)
			m_nCurrentConfig++;
		m_ConfigList.SetItemData(nIndex, (long)pInfo);
		m_ProjectConfigList.AddHead(pInfo);
		if (pInfo->ConfigName == s)
		{
			m_ConfigList.SetItemState(nIndex, m_ConfigList.GetItemState(nIndex, LVIS_SELECTED) | LVIS_SELECTED, LVIS_SELECTED);
		}
	}
	UpdateData(FALSE);
	UpdateConfigInfo();

	UpdateCompiledName();
	bReady = TRUE;

	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CProjectSettingsDialog::OnOk() 
{
	UpdateData(TRUE);

	switch (m_nProjectType)
	{
	case 0:
		m_pProject->m_ProjectType = "Directory";
		break;
	case 1:
		m_pProject->m_ProjectType = "Individual";
		break;
	case 2:
		m_pProject->m_ProjectType = "Library";
		break;
	default:
		m_CompiledName = "Directory";
		ASSERT(FALSE);
	}
	m_pProject->m_nROMID = m_nROMID;
	m_pProject->m_ProjectConfigList.RemoveAll();
	int nIndex = 0, nDefaultIndex = -1;
	m_pProject->m_nCurrentConfig = -1;

	CString s1;
	s1.LoadString(IDS_DEFAULTCONFIG);
	CString s2;
	s2.LoadString(IDS_NEWCONFIG);
	POSITION pos;

	for (pos = m_ProjectConfigList.GetHeadPosition();
		pos != NULL;
		m_ProjectConfigList.GetNext(pos))
	{
		PROJECT_CONFIG_INFO Info = *m_ProjectConfigList.GetAt(pos);
		if (Info.ConfigName == s2)
		{
			AfxMessageBox(IDS_CONFIGNOTNAMED);
			return;
		}
	}

	for (pos = m_ProjectConfigList.GetHeadPosition();
		pos != NULL;
		m_ProjectConfigList.GetNext(pos))
	{
		PROJECT_CONFIG_INFO Info = *m_ProjectConfigList.GetAt(pos);
		m_pProject->m_ProjectConfigList.Add(Info);
		if (Info.ConfigName == m_OriginalConfig)
			m_pProject->m_nCurrentConfig = nIndex;
		if (Info.ConfigName == s1)
			nDefaultIndex = nIndex;
		nIndex++;
	}
	if (m_pProject->m_nCurrentConfig == -1)
	{
		m_pProject->m_nCurrentConfig = nDefaultIndex;
	}
	CDialog::OnOK();
}

void CProjectSettingsDialog::UpdateCompiledName(BOOL bUpdateBoxes /* = TRUE */)
{
	UpdateData(TRUE);
	m_CompiledName = m_Filename;

	switch (m_nProjectType)
	{
	case 0:
		m_CompiledName += ".dir";
		break;
	case 1:
		m_CompiledName = "*.gx";
		break;
	case 2:
		m_CompiledName += ".lib";
		break;
	default:
		m_CompiledName = "<<INVALID>>";
		ASSERT(FALSE);
	}

	if (bUpdateBoxes)
	{
		GetDlgItem(IDC_SETTINGS_PROJECTFILENAME)->EnableWindow(m_nProjectType != 1);
		GetDlgItem(IDC_SETTINGS_PROJECTROMID)->EnableWindow(m_nProjectType == 2);
	}

	UpdateData(FALSE);
}

void CProjectSettingsDialog::OnSettingsDirectory() 
{
	UpdateCompiledName();
	GetDlgItem(IDC_SETTINGS_PROJECTFILENAME)->EnableWindow(TRUE);
}

void CProjectSettingsDialog::OnSettingsLibrary() 
{
	UpdateCompiledName();
	GetDlgItem(IDC_SETTINGS_PROJECTFILENAME)->EnableWindow(TRUE);
}

void CProjectSettingsDialog::OnSettingsIndividualfiles() 
{
	UpdateCompiledName();
	UpdateData(FALSE);
	GetDlgItem(IDC_SETTINGS_PROJECTFILENAME)->EnableWindow(FALSE);
}

void CProjectSettingsDialog::OnDblclkSettingsConfigurationlist(NMHDR* pNMHDR, LRESULT* pResult) 
{
	*pResult = 0;
}

void CProjectSettingsDialog::UpdateConfigInfo()
{
	UpdateData(TRUE);
	int nIndex = m_ConfigList.GetNextItem(-1, LVNI_SELECTED);
	if (nIndex == m_nCurrentConfig && nIndex != -1)
		return;
	if (m_nCurrentConfig != -1)
	{
		PROJECT_CONFIG_INFO * pInfo = (PROJECT_CONFIG_INFO*)m_ConfigList.GetItemData(m_nCurrentConfig);
		ASSERT(pInfo != NULL);
		pInfo->LibraryTitle = m_LibraryTitle;
		pInfo->BaseFilename = m_Filename;
	}

	if (nIndex == -1)
	{
		m_Filename = "";
		m_LibraryTitle = "";
		GetDlgItem(IDC_SETTINGS_PROJECTFILENAME)->EnableWindow(FALSE);
		GetDlgItem(IDC_SETTINGS_DESCRIPTION)->EnableWindow(FALSE);
	}
	else
	{
		PROJECT_CONFIG_INFO * pInfo = (PROJECT_CONFIG_INFO*)m_ConfigList.GetItemData(nIndex);
		ASSERT(pInfo != NULL);
		m_Filename = pInfo->BaseFilename;
		m_LibraryTitle = pInfo->LibraryTitle;
		GetDlgItem(IDC_SETTINGS_PROJECTFILENAME)->EnableWindow(TRUE);
		GetDlgItem(IDC_SETTINGS_DESCRIPTION)->EnableWindow(TRUE);	
	}
	m_nCurrentConfig = nIndex;
	UpdateData(FALSE);
	UpdateCompiledName(FALSE);
}

void CProjectSettingsDialog::OnEndlabeleditSettingsConfigurationlist(NMHDR* pNMHDR, LRESULT* pResult) 
{
	LV_DISPINFO* pDispInfo = (LV_DISPINFO*)pNMHDR;
	*pResult = 0;
	if (pDispInfo->item.pszText == NULL)
		return;

	strupr(pDispInfo->item.pszText);
	CString s = pDispInfo->item.pszText;
	s.TrimLeft();
	s.TrimRight();
	if (s.GetLength() == 0)
		return;

	PROJECT_CONFIG_INFO * pInfo = (PROJECT_CONFIG_INFO*)m_ConfigList.GetItemData(pDispInfo->item.iItem);
	for (POSITION pos = m_ProjectConfigList.GetHeadPosition(); 
		pos != NULL; 
		m_ProjectConfigList.GetNext(pos))
	{
		PROJECT_CONFIG_INFO * pOtherInfo = m_ProjectConfigList.GetAt(pos);
		if (pInfo != pOtherInfo)
		{
			if (s == pOtherInfo->ConfigName)
			{
				AfxMessageBox(IDS_CONFIGALREADYEXISTS, MB_OK | MB_ICONEXCLAMATION);
				return;
			}	
		}
	}
	*pResult = 1;
	pInfo->ConfigName = s; 
	strcpy(pDispInfo->item.pszText, s);
}

void CProjectSettingsDialog::OnBeginlabeleditSettingsConfigurationlist(NMHDR* pNMHDR, LRESULT* pResult) 
{
	LV_DISPINFO* pDispInfo = (LV_DISPINFO*)pNMHDR;
	CString s;
	s.LoadString(IDS_DEFAULTCONFIG);
	PROJECT_CONFIG_INFO * pInfo = (PROJECT_CONFIG_INFO*)m_ConfigList.GetItemData(pDispInfo->item.iItem);
	if (pInfo->ConfigName != s)
		*pResult = 0;
	else
		*pResult = 1;
}

void CProjectSettingsDialog::OnSettingsAddconfig() 
{
	int nIndex = m_ConfigList.GetNextItem(-1, LVNI_SELECTED);
	if (nIndex != -1)
	{
		m_ConfigList.SetItemState(nIndex, 0, LVIS_SELECTED);	
	}
	CString s;
	s.LoadString(IDS_NEWCONFIG);
	int nItem = m_ConfigList.InsertItem(0, s);
	PROJECT_CONFIG_INFO * pInfo = new PROJECT_CONFIG_INFO;
	m_ProjectConfigList.AddHead(pInfo);
	pInfo->ConfigName = s;
	s.LoadString(IDS_DEFAULTCONFIG);
	for (POSITION pos = m_ProjectConfigList.GetHeadPosition();
		pos != NULL;
		m_ProjectConfigList.GetNext(pos))
	{
		PROJECT_CONFIG_INFO * pDefaultInfo = m_ProjectConfigList.GetAt(pos);
		if (pDefaultInfo->ConfigName == s)
		{
			pInfo->BaseFilename = pDefaultInfo->BaseFilename;
			pInfo->LibraryTitle = pDefaultInfo->LibraryTitle;
			break;
		}
	}
	m_ConfigList.SetItemData(nItem, (long)pInfo);
	m_ConfigList.SetItemState(nItem, LVIS_SELECTED, LVIS_SELECTED);
	m_ConfigList.SetFocus();
	UpdateConfigInfo();
}

void CProjectSettingsDialog::OnChangeSettingsProjectfilename() 
{
	UpdateCompiledName();	
}

void CProjectSettingsDialog::OnSelchangeSettingsProjecttype() 
{
	UpdateCompiledName();
}

void CProjectSettingsDialog::OnItemchangedSettingsConfigurationlist(NMHDR* pNMHDR, LRESULT* pResult) 
{
	NM_LISTVIEW* pNMListView = (NM_LISTVIEW*)pNMHDR;

	if (bReady)
		UpdateConfigInfo();
	
	*pResult = 0;
}

void CProjectSettingsDialog::OnClose() 
{
	CDialog::OnClose();
}

void CProjectSettingsDialog::OnCancel() 
{
	CDialog::OnCancel();
}

void CProjectSettingsDialog::OnKeydownSettingsConfigurationlist(NMHDR* pNMHDR, LRESULT* pResult) 
{
	LV_KEYDOWN* pLVKeyDow = (LV_KEYDOWN*)pNMHDR;
	
	if (pLVKeyDow->wVKey == VK_DELETE)
	{
		int nItem = m_ConfigList.GetNextItem(-1, LVNI_SELECTED);
		if (nItem != -1)
		{
			CString s1;
			CString s2;
			s2.LoadString(IDS_DEFAULTCONFIG);
			CString ConfigName = m_ConfigList.GetItemText(nItem, 0);
			if (ConfigName != s2)
			{
				AfxFormatString1(s1, IDS_DELETECONFIG, ConfigName);
				if (AfxMessageBox(s1, MB_ICONQUESTION | MB_YESNO) == IDYES)
				{
					PROJECT_CONFIG_INFO * pInfo = (PROJECT_CONFIG_INFO*)m_ConfigList.GetItemData(nItem);
					POSITION pos = m_ProjectConfigList.Find(pInfo, NULL);
					ASSERT(pos != NULL);
					m_ProjectConfigList.RemoveAt(pos);
					delete pInfo;				
					m_nCurrentConfig = -1;
					m_ConfigList.DeleteItem(nItem);
				}
			}
			else
			{
				AfxMessageBox(IDS_DELETEDEFAULT, MB_ICONERROR | MB_OK);
			}
		}
	}
	
	*pResult = 0;
}
