// SourceDocument.cpp : implementation file
//

#include "stdafx.h"
#include "HPIDE.h"
#include "SourceDocument.h"
#include "SourceEditView.h"
#include "BuildProgressDialog.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CSourceDocument

IMPLEMENT_DYNCREATE(CSourceDocument, CDocument)

CSourceDocument::CSourceDocument()
{
}

BOOL CSourceDocument::OnNewDocument()
{
	if (!CDocument::OnNewDocument())
		return FALSE;
	return TRUE;
}

CSourceDocument::~CSourceDocument()
{
}


BEGIN_MESSAGE_MAP(CSourceDocument, CDocument)
	//{{AFX_MSG_MAP(CSourceDocument)
	ON_UPDATE_COMMAND_UI(ID_BUILD_COMPILE, OnUpdateBuildCompile)
	ON_UPDATE_COMMAND_UI(ID_BUILD_RUN, OnUpdateBuildRun)
	ON_UPDATE_COMMAND_UI(ID_BUILD_TRANSFER, OnUpdateBuildTransfer)
	ON_COMMAND(ID_PROJECT_ADDCURRENTFILE, OnProjectAddcurrentfile)
	ON_COMMAND(ID_BUILD_COMPILE, OnBuildCompile)
	ON_UPDATE_COMMAND_UI(ID_PROJECT_ADDCURRENTFILE, OnUpdateProjectAddcurrentfile)
	ON_UPDATE_COMMAND_UI(ID_PROJECT_TOGGLECOMPILE, OnUpdateProjectTogglecompile)
	ON_COMMAND(ID_PROJECT_TOGGLECOMPILE, OnProjectTogglecompile)
	ON_UPDATE_COMMAND_UI(ID_PROJECT_TOGGLEFILEVISIBILITY, OnUpdateProjectTogglefilevisibility)
	ON_COMMAND(ID_PROJECT_TOGGLEFILEVISIBILITY, OnProjectTogglefilevisibility)
	ON_COMMAND(ID_BUILD_TRANSFER, OnBuildTransfer)
	ON_COMMAND(ID_BUILD_SIMULATE, OnBuildSimulate)
	ON_UPDATE_COMMAND_UI(ID_BUILD_SIMULATE, OnUpdateBuildSimulate)
	ON_UPDATE_COMMAND_UI(ID_EDIT_TEMPLATES_TEMPLATE1, OnUpdateEditTemplatesTemplate1)
	ON_UPDATE_COMMAND_UI(ID_EDIT_TEMPLATES_TEMPLATE2, OnUpdateEditTemplatesTemplate2)
	ON_UPDATE_COMMAND_UI(ID_EDIT_TEMPLATES_TEMPLATE3, OnUpdateEditTemplatesTemplate3)
	ON_UPDATE_COMMAND_UI(ID_EDIT_TEMPLATES_TEMPLATE4, OnUpdateEditTemplatesTemplate4)
	ON_UPDATE_COMMAND_UI(ID_EDIT_TEMPLATES_TEMPLATE5, OnUpdateEditTemplatesTemplate5)
	ON_COMMAND(ID_EDIT_TEMPLATES_TEMPLATE1, OnEditTemplatesTemplate1)
	ON_COMMAND(ID_EDIT_TEMPLATES_TEMPLATE2, OnEditTemplatesTemplate2)
	ON_COMMAND(ID_EDIT_TEMPLATES_TEMPLATE3, OnEditTemplatesTemplate3)
	ON_COMMAND(ID_EDIT_TEMPLATES_TEMPLATE4, OnEditTemplatesTemplate4)
	ON_COMMAND(ID_EDIT_TEMPLATES_TEMPLATE5, OnEditTemplatesTemplate5)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CSourceDocument diagnostics

#ifdef _DEBUG
void CSourceDocument::AssertValid() const
{
	CDocument::AssertValid();
}

void CSourceDocument::Dump(CDumpContext& dc) const
{
	CDocument::Dump(dc);
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CSourceDocument serialization

void CSourceDocument::Serialize(CArchive& ar)
{
	if (ar.IsStoring())
	{
		POSITION pos = GetFirstViewPosition();
		CSourceEditView* pView = (CSourceEditView*)GetNextView(pos);
		pView->SerializeRaw(ar);
	}
	else
	{
		POSITION pos = GetFirstViewPosition();
		CSourceEditView* pView = (CSourceEditView*)GetNextView(pos);
		int nMaxSize = 65000;
		CFile* pFile = ar.GetFile();
		ASSERT(pFile->GetPosition() == 0);
		DWORD nFileSize = pFile->GetLength();
		LPVOID hText = LocalAlloc(LMEM_MOVEABLE, nMaxSize + 1);
		LPTSTR c = (LPTSTR)LocalLock(hText);
		ASSERT(c != NULL);
		int nIndex = 0;
		try
		{
			while (nIndex < nMaxSize)
			{
				char* pString = ar.ReadString(c + nIndex, nMaxSize - nIndex - 3);
				if (!pString)
					break;
				int nLen = strlen(pString);
				pString[nLen] = 0x0d;
				pString[nLen + 1] = 0x0a;
				nIndex += nLen + 2;
			}
			c[nIndex] = '\0';
		}
		catch (CException e)
		{
		}
		if (nIndex < nMaxSize)
		{
			BOOL bResult = ::SetWindowText(pView->m_hWnd, c);
		}
		else
		{
			LocalUnlock(hText);
			LocalFree(hText);
			AfxMessageBox(AFX_IDP_FILE_TOO_LARGE);
			AfxThrowUserException();
		}
		LocalUnlock(hText);
		LocalFree(hText);
	}
}

/////////////////////////////////////////////////////////////////////////////
// CSourceDocument commands

void CSourceDocument::OnUpdateBuildCompile(CCmdUI* pCmdUI) 
{
	CString Title = GetTitle();
	if (Title.Right(2) == " *")
		Title = Title.Left(Title.GetLength() - 2);

	if (Title.Right(2) == (".s") || Title.Right(2) == (".S"))
	{
		Title = Title.Left(Title.GetLength() - 2);
		pCmdUI->SetText(CString("Compile ") + Title + ".gx\tF7");
		pCmdUI->Enable(TRUE);
	}
}

void CSourceDocument::OnUpdateBuildRun(CCmdUI* pCmdUI) 
{
	CString Title = GetTitle();
	if (Title.Right(2) == " *")
		Title = Title.Left(Title.GetLength() - 2);
	if (Title.Right(2) == (".s") || Title.Right(2) == (".S"))
	{		
		Title = Title.Left(Title.GetLength() - 2);
		pCmdUI->SetText(CString("Run ") + Title + ".gx on HP48\tAlt-F7");
		pCmdUI->Enable(TRUE);
	}
}

void CSourceDocument::OnUpdateBuildTransfer(CCmdUI* pCmdUI)
{
	CString Title = GetTitle();
	if (Title.Right(2) == " *")
		Title = Title.Left(Title.GetLength() - 2);
	if (Title.Right(2) == (".s") || Title.Right(2) == (".S"))
	{
		Title = Title.Left(Title.GetLength() - 2);
		pCmdUI->SetText(CString("Transfer ") + Title + ".gx to HP48\tCtrl+F7");
		pCmdUI->Enable(TRUE);
	}
}

void CSourceDocument::OnBuildSimulate() 
{
	CString FilePath, Filename;
	char* pPath = FilePath.GetBuffer(MAX_PATH);
	char* pFilename;
	GetFullPathName(GetPathName(), MAX_PATH, pPath, &pFilename);
	Filename = pFilename;
	CString ActualPath = pPath;
	ActualPath = ActualPath.Left(pFilename - pPath);
	FilePath.ReleaseBuffer();

	if (Filename.Right(2) == (".s"))
		Filename = Filename.Left(Filename.GetLength() - 2);
	if (Filename.Right(2) == (".S"))
		Filename = Filename.Left(Filename.GetLength() - 2);
	
	CString TransferPath = GetMainWnd()->m_pCurrentProject->GetProjectDir();
	if (TransferPath == "")
		TransferPath = ActualPath;
	CString HPName;

	PROJECT_FILE_INFO Info;
	CString FullFilename = GetPathName();
	if (FullFilename.Left(TransferPath.GetLength()) == TransferPath)
		FullFilename = FullFilename.Mid(TransferPath.GetLength());
	GetMainWnd()->m_pCurrentProject->GetFileInfo(FullFilename, Info);
	HPName = Info.HPName;
	GetMainWnd()->Simulate(TransferPath 
		+ GetMainWnd()->GetSettingString("CompiledDir") + "\\" 
		+ Filename + ".gx");
}

void CSourceDocument::OnUpdateBuildSimulate(CCmdUI* pCmdUI) 
{
	CString Title = GetTitle();
	if (Title.Right(2) == " *")
		Title = Title.Left(Title.GetLength() - 2);
	if (Title.Right(2) == (".s") || Title.Right(2) == (".S"))
	{
		Title = Title.Left(Title.GetLength() - 2);
		pCmdUI->SetText(CString("Simulate ") + Title + ".gx\tAlt+F7");
		pCmdUI->Enable(TRUE);
	}
}

void CSourceDocument::OnProjectAddcurrentfile() 
{
	if (GetMainWnd()->m_pCurrentProject->GetPathName().IsEmpty())
		AfxMessageBox(IDS_ADDINGTOUNSAVEDPROJECT);
	else
		GetMainWnd()->m_pCurrentProject->AddFileToProject(GetPathName());
}

void CSourceDocument::OnBuildCompile() 
{
	OnFileSave();
	CBuildProgressDialog dlg;
	dlg.Create();

	CString s;
	s.LoadString(IDS_COMPILINGCURRENTFILE);
	dlg.SetStatus(s);
	dlg.SetPos(0);
	dlg.SetRange(0, 3);
	dlg.SetStep(1);
	GetMainWnd()->Compile(GetPathName(), &dlg);
}

void CSourceDocument::OnUpdateProjectAddcurrentfile(CCmdUI* pCmdUI) 
{
	if (GetPathName().IsEmpty())
	{
		pCmdUI->Enable(FALSE);
		return;
	}
	pCmdUI->Enable(GetPathName() != "");	
}

void CSourceDocument::OnUpdateProjectTogglecompile(CCmdUI* pCmdUI) 
{
/*	PROJECT_FILE_INFO Info;
	if (((CMainFrame*)(AfxGetMainWnd()))->m_pCurrentProject->GetFileInfo(GetPathName(), Info))
	{
		pCmdUI->Enable(TRUE);
		pCmdUI->SetCheck(Info.bCompile);
	}
	else
	{*/
		pCmdUI->Enable(FALSE);
		pCmdUI->SetCheck(FALSE);
//	}
}

void CSourceDocument::OnProjectTogglecompile() 
{
	PROJECT_FILE_INFO Info;
	(((CMainFrame*)(AfxGetMainWnd()))->m_pCurrentProject->GetFileInfo(GetPathName(), Info));
	Info.bCompile = !Info.bCompile;
	(((CMainFrame*)(AfxGetMainWnd()))->m_pCurrentProject->SetFileInfo(GetPathName(), Info));
}

void CSourceDocument::OnUpdateProjectTogglefilevisibility(CCmdUI* pCmdUI) 
{
/*	PROJECT_FILE_INFO Info;
	if (((CMainFrame*)(AfxGetMainWnd()))->m_pCurrentProject->GetFileInfo(GetPathName(), Info))
	{
		pCmdUI->Enable(TRUE);
		pCmdUI->SetCheck(Info.bVisible);
	}
	else
	{*/
		pCmdUI->Enable(FALSE);
		pCmdUI->SetCheck(FALSE);
//	}
}

void CSourceDocument::OnProjectTogglefilevisibility() 
{
	PROJECT_FILE_INFO Info;
	(((CMainFrame*)(AfxGetMainWnd()))->m_pCurrentProject->GetFileInfo(GetPathName(), Info));
	Info.bVisible = !Info.bVisible;
	(((CMainFrame*)(AfxGetMainWnd()))->m_pCurrentProject->SetFileInfo(GetPathName(), Info));
}

BOOL CSourceDocument::OnOpenDocument(LPCTSTR lpszPathName) 
{
	if (!((CMainFrame*)(AfxGetMainWnd()))->m_pCurrentProject)
	{
		GetMainWnd()->NewProject();
	}
	
	if (!CDocument::OnOpenDocument(lpszPathName))
		return FALSE;
	
	return TRUE;
}

void CSourceDocument::OnBuildTransfer() 
{
	CString FilePath, Filename;
	char* pPath = FilePath.GetBuffer(MAX_PATH);
	char* pFilename;
	GetFullPathName(GetPathName(), MAX_PATH, pPath, &pFilename);
	Filename = pFilename;
	CString ActualPath = pPath;
	ActualPath = ActualPath.Left(pFilename - pPath);
	FilePath.ReleaseBuffer();

	if (Filename.Right(2) == (".s"))
		Filename = Filename.Left(Filename.GetLength() - 2);
	if (Filename.Right(2) == (".S"))
		Filename = Filename.Left(Filename.GetLength() - 2);
	
	CString TransferPath = GetMainWnd()->m_pCurrentProject->GetProjectDir();
	if (TransferPath == "")
		TransferPath = ActualPath;
	CString HPName;

	PROJECT_FILE_INFO Info;
	CString FullFilename = GetPathName();
	if (FullFilename.Left(TransferPath.GetLength()) == TransferPath)
		FullFilename = FullFilename.Mid(TransferPath.GetLength());
	GetMainWnd()->m_pCurrentProject->GetFileInfo(FullFilename, Info);
	HPName = Info.HPName;
	GetMainWnd()->Transfer(TransferPath 
		+ GetMainWnd()->GetSettingString("CompiledDir") + "\\" 
		+ Filename + ".gx", HPName);
}

void CSourceDocument::OnUpdateEditTemplatesTemplate1(CCmdUI* pCmdUI) 
{
	if (!GetMainWnd()->GetSettingString("TemplatePath1").IsEmpty())
	{
		pCmdUI->SetText(GetMainWnd()->GetSettingString("TemplateName1") + "\tCtrl+Shift+1");
	}
	else
		pCmdUI->Enable(FALSE);
}

void CSourceDocument::OnUpdateEditTemplatesTemplate2(CCmdUI* pCmdUI) 
{
	if (!GetMainWnd()->GetSettingString("TemplatePath2").IsEmpty())
	{
		pCmdUI->SetText(GetMainWnd()->GetSettingString("TemplateName2") + "\tCtrl+Shift+2");	
	}
	else
		pCmdUI->Enable(FALSE);
}

void CSourceDocument::OnUpdateEditTemplatesTemplate3(CCmdUI* pCmdUI) 
{
	if (!GetMainWnd()->GetSettingString("TemplatePath3").IsEmpty())
	{
		pCmdUI->SetText(GetMainWnd()->GetSettingString("TemplateName3") + "\tCtrl+Shift+3");	
	}
	else
		pCmdUI->Enable(FALSE);
}

void CSourceDocument::OnUpdateEditTemplatesTemplate4(CCmdUI* pCmdUI) 
{
	if (!GetMainWnd()->GetSettingString("TemplatePath4").IsEmpty())
	{
		pCmdUI->SetText(GetMainWnd()->GetSettingString("TemplateName4") + "\tCtrl+Shift+4");	
	}
	else
		pCmdUI->Enable(FALSE);
}

void CSourceDocument::OnUpdateEditTemplatesTemplate5(CCmdUI* pCmdUI) 
{
	if (!GetMainWnd()->GetSettingString("TemplatePath5").IsEmpty())
	{
		pCmdUI->SetText(GetMainWnd()->GetSettingString("TemplateName5") + "\tCtrl+Shift+5");	
	}
	else
		pCmdUI->Enable(FALSE);
}

void CSourceDocument::OnEditTemplatesTemplate1() 
{
	InsertTemplate(GetMainWnd()->GetSettingString("TemplateLocation") + "\\"
		+ GetMainWnd()->GetSettingString("TemplatePath1"));
}

void CSourceDocument::OnEditTemplatesTemplate2() 
{
	InsertTemplate(GetMainWnd()->GetSettingString("TemplateLocation") + "\\"
		+ GetMainWnd()->GetSettingString("TemplatePath2"));
}

void CSourceDocument::OnEditTemplatesTemplate3() 
{
	InsertTemplate(GetMainWnd()->GetSettingString("TemplateLocation") + "\\"
		+ GetMainWnd()->GetSettingString("TemplatePath3"));
}

void CSourceDocument::OnEditTemplatesTemplate4() 
{
	InsertTemplate(GetMainWnd()->GetSettingString("TemplateLocation") + "\\"
		+ GetMainWnd()->GetSettingString("TemplatePath4"));
}

void CSourceDocument::OnEditTemplatesTemplate5() 
{
	InsertTemplate(GetMainWnd()->GetSettingString("TemplateLocation") + "\\"
		+ GetMainWnd()->GetSettingString("TemplatePath5"));
}

void CSourceDocument::InsertTemplate(CString TemplatePath)
{
	TRY
	{
		POSITION pos = GetFirstViewPosition();
		CSourceEditView* pView = (CSourceEditView*)GetNextView(pos);
		CEdit& Edit = pView->GetEditCtrl();
		int nStart, nEnd;
		Edit.GetSel(nStart, nEnd);
		CFile f(TemplatePath, CFile::modeRead);
		DWORD dwLength = f.GetLength();
		char * pText = new char[dwLength + 1];
		f.Read(pText, dwLength);
		pText[dwLength] = '\0';
		Edit.ReplaceSel(pText);
		Edit.SetSel(nStart, nStart);
		delete[] pText;
	}
	CATCH (CException, e)
	{
		CString s;
		e->ReportError();
	}
	END_CATCH
}
