// TipDialog.cpp : implementation file
//

#include "stdafx.h"
#include "HPIDE.h"
#include "TipDialog.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CTipDialog dialog

/*CString Tips[] =
{
	"Welcome to HP-IDE!  You can disable these tips on startup with the "
	"checkbox below.  If you've disabled them, you can always reenable them "
	"from the Tip of the Day option under Help or the Program Options dialog.  "
	"There are lots of good tips in here, so you should probably leave "
	"them on for at least a little while.  \n\nEnjoy!"
	,
	"The official HP-IDE homepage is currently at:\n\n"
	"http://www.acs.ucalgary.ca/~mmastrac/hp-ide\n\n"
	"Here, you can find all sorts of neat things, like the HP-IDE mailing "
	"list information, a wishlist and program news."
	,
	"The order of the objects in a directory or library is the same as their "
	"order in the project.  Use the file up/down commands on the project "
	"toolbar to shift them into the order you want them to go."
	,
	"You can use the HP's special characters in the library and object names "
	"by using the escape codes on page 27-16 of your HP manual."
	,
	"Using multiple project configurations is a good way to maintain multiple "
	"versions of a program that have different features.  You can create "
	"a regular version and a lite version, for example."
	,
	"Simulating projects with EMU48 is a lot easier on your batteries than "
	"transferring the program over and over.  You need to download the version "
	"specifically designed to work with HP-IDE, however (from the HP-IDE website)."
	,
	"If your directory looks odd on your HP48 or your library won't compile/attach "
	"properly, you may have an invalid object somewhere in it.  Upload the individual "  
	"objects to the HP48 and see which ones are invalid or fail to transfer properly."
	,
	"To open multiple source files at a time, use the File/Open command, but instead "
	"drag the files you want out of the dialog and into the main window.  You can also "
	"drag and drop from Windows Explorer with both projects and source files."
	,
	"Use source templates to make repetitive tasks (like NIBASC headers and "
	"parameterized outer loops) easier.  A few templates are included to start you off, "
	"but you can edit them to suit your needs."
	,
	"If your assembler opcode isn't indented, SASM will treat it as a label "
	"and your source may not work/compile correctly."
	,
	"If you don't have the \"NIBASC /HPHP48-x/\" header in your source files you "
	"won't be able to upload them directly, but you can still build a valid "
	"library or directory (you'll get a warning, however)."
	,
	"You can't close a project by using the close box on the caption bar.  "
	"Use the Close Project toolbar button or menu option instead."
	,
	"To override the default config file generation, just delete ProjectConfig.s "
	"from the project and then add your own file (with a different name) and "
	"make its compiled name '$CONFIG'."
	,
	"You can include header files in your project for convenience if you set their "
	"compile flag to 'No'."
	,
	"You can specify library variables to be stored in user memory with the "
	"$VARS objects.  See the USRLIB documentation for more information."
};
*/

CTipDialog::CTipDialog(CWnd* pParent /*=NULL*/)
	: CDialog(CTipDialog::IDD, pParent)
{
	//{{AFX_DATA_INIT(CTipDialog)
	m_TipString = _T("");
	m_bShowTips = FALSE;
	//}}AFX_DATA_INIT
}


void CTipDialog::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CTipDialog)
	DDX_Text(pDX, IDC_TIP_TIPTEXT, m_TipString);
	DDX_Check(pDX, IDC_TIP_SHOWTIPS, m_bShowTips);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CTipDialog, CDialog)
	//{{AFX_MSG_MAP(CTipDialog)
	ON_EN_SETFOCUS(IDC_TIP_TIPTEXT, OnSetfocusTipTiptext)
	ON_BN_CLICKED(IDC_TIP_NEXTTIP, OnTipNexttip)
	ON_BN_CLICKED(IDC_TIP_SHOWTIPS, OnTipShowtips)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CTipDialog message handlers

BOOL CTipDialog::OnInitDialog() 
{
	GetDlgItem(IDC_TIP_TIPTEXT)->SetFont(&((CHPIDEApp*)AfxGetApp())->m_TipFont, TRUE);
	CDialog::OnInitDialog();

	int nTip = GetMainWnd()->GetSettingInt("TipNum");
	if (nTip >= sizeof(Tips) / sizeof(CString))
		nTip = 0;
	m_TipString = Tips[nTip];
	m_bShowTips = GetMainWnd()->GetSettingBool("ShowTips");
	UpdateData(FALSE);
	nTip++;
	CString TipNum;
	TipNum.Format("%i", nTip);
	GetMainWnd()->ChangeSetting("TipNum", TipNum);
	GetMainWnd()->WriteSetting("TipNum");
	// TODO: Add extra initialization here
	
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CTipDialog::OnSetfocusTipTiptext() 
{
	GetDlgItem(IDC_TIP_SHOWTIPS)->SetFocus();	
}

void CTipDialog::OnTipNexttip() 
{
	int nTip = GetMainWnd()->GetSettingInt("TipNum");
	if (nTip >= sizeof(Tips) / sizeof(CString))
		nTip = 0;
	m_TipString = Tips[nTip];
	UpdateData(FALSE);
	nTip++;
	CString TipNum;
	TipNum.Format("%i", nTip);
	GetMainWnd()->ChangeSetting("TipNum", TipNum);
	GetMainWnd()->WriteSetting("TipNum");
}

void CTipDialog::OnTipShowtips() 
{
	UpdateData(TRUE);
	GetMainWnd()->ChangeSetting("ShowTips", m_bShowTips ? "Yes" : "No");
	GetMainWnd()->WriteSetting("ShowTips");
}
