// TransferInProgressDialog.cpp : implementation file
//

#include "stdafx.h"
#include "HPIDE.h"
#include "TransferInProgressDialog.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

#define WM_UPDATETEXT		(WM_USER)
#define WM_UPDATEPROGRESS	(WM_USER + 1)

/////////////////////////////////////////////////////////////////////////////
// CTransferInProgressDialog dialog


CTransferInProgressDialog::CTransferInProgressDialog(CWnd* pParent /*=NULL*/)
	: CDialog(CTransferInProgressDialog::IDD, pParent)
{
	//{{AFX_DATA_INIT(CTransferInProgressDialog)
	m_Filename = _T("");
	m_Status = _T("");
	//}}AFX_DATA_INIT
}

CTransferInProgressDialog::~CTransferInProgressDialog()
{
	Finish();
}

void CTransferInProgressDialog::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CTransferInProgressDialog)
	DDX_Control(pDX, IDC_TRANSFER_PROGRESS, m_Progress);
	DDX_Text(pDX, IDC_TRANSFER_FILENAME, m_Filename);
	DDX_Text(pDX, IDC_TRANSFER_STATUS, m_Status);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CTransferInProgressDialog, CDialog)
	//{{AFX_MSG_MAP(CTransferInProgressDialog)
	ON_MESSAGE(WM_UPDATETEXT, OnUpdateText)
	ON_MESSAGE(WM_UPDATEPROGRESS, OnUpdateProgress)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CTransferInProgressDialog message handlers

UINT XmodemThread(CTransferInProgressDialog* pDlg)
{
	HWND hWnd = HWND(*pDlg);
	CString COMPort;
	COMPort.Format("COM%i", pDlg->m_nCOMPort);
	HANDLE hCom = CreateFile(
		COMPort,
		GENERIC_READ | GENERIC_WRITE,
		0, /* exclusive access */
		NULL, /* no security attrs */
		OPEN_EXISTING,
		0,
		NULL
	);
	if (hCom == INVALID_HANDLE_VALUE)
	{
		int nError = GetLastError();
		CString Message;
		Message.Format("Couldn't open port %s (Error: %i)!", COMPort, nError);
		MessageBox(hWnd, Message, "Transfer Error", MB_ICONERROR | MB_OK);
		SetEvent(pDlg->m_hTransferDone);
		PostMessage(hWnd, WM_CLOSE, 0, 0);
		return 0xffffffff;
	}
	HANDLE hFile = CreateFile(
		pDlg->m_Filename,
		GENERIC_READ,
		0,
		NULL,
		OPEN_EXISTING,
		0,
		NULL
	);
	if (hFile == INVALID_HANDLE_VALUE)
	{
		CloseHandle(hCom);
		int nError = GetLastError();
		CString Message;
		Message.Format("Couldn't open file %s (Error: %i)!", pDlg->m_Filename, nError);
		MessageBox(hWnd, Message, "Transfer Error", MB_ICONERROR | MB_OK);
		SetEvent(pDlg->m_hTransferDone);
		PostMessage(hWnd, WM_CLOSE, 0, 0);
		return 0xffffffff;
	}

	SetupComm(hCom, 15000, 15000);
	DCB dcb;
	GetCommState(hCom, &dcb);

	dcb.BaudRate = pDlg->m_nBaudRate;
	dcb.ByteSize = 8;
	dcb.Parity = NOPARITY;
	dcb.StopBits = ONESTOPBIT;
	dcb.fDtrControl = DTR_CONTROL_DISABLE;
	dcb.fRtsControl = RTS_CONTROL_DISABLE;
	SetCommState(hCom, &dcb);

	COMMTIMEOUTS Timeouts;
	GetCommTimeouts(hCom, &Timeouts);
	Timeouts.ReadIntervalTimeout = 500;
    Timeouts.ReadTotalTimeoutMultiplier = 10;
    Timeouts.ReadTotalTimeoutConstant = 1000; 
	Timeouts.WriteTotalTimeoutConstant = 1000;
	Timeouts.WriteTotalTimeoutMultiplier = 2;
	SetCommTimeouts(hCom, &Timeouts);
	BOOL bDone = FALSE;
	PostMessage(hWnd, WM_UPDATETEXT, 0, 0);
	int nSize = GetFileSize(hFile, NULL);
	if (nSize == 0)
	{
		int nError = GetLastError();
		CString Message = "File is zero length";
		MessageBox(hWnd, Message, "Transfer Done", MB_ICONINFORMATION | MB_OK);
		SetEvent(pDlg->m_hTransferDone);
		PostMessage(hWnd, WM_CLOSE, 0, 0);
		CloseHandle(hFile);
		CloseHandle(hCom);
		return 0xffffffff;
	}
	int nPos = 0;
	DWORD BUFFER_SIZE = 128 + 4;
	char* pBuffer = new char[BUFFER_SIZE];
	int nPacket = 1;
	DWORD dwError = 0;
	COMSTAT ComStat;
	ClearCommError(hCom, &dwError, &ComStat);
	CString Filepath;
	char* pPath = Filepath.GetBuffer(MAX_PATH);
	char* pFilename;
	GetFullPathName(pDlg->m_Filename, MAX_PATH, pPath, &pFilename);
	CString FilenamePart = pFilename;
	Filepath.ReleaseBuffer();
	if (pDlg->m_HPName != "")
		FilenamePart = pDlg->m_HPName;
	FilenamePart = "Filename: '" + FilenamePart + "'";
	DWORD nWritten = 0;
	WriteFile(hCom, FilenamePart, FilenamePart.GetLength(), &nWritten, NULL);
	BOOL bWaitForStart = TRUE;
	CTime StartTime;
	while (!bDone)
	{
		CString Status;
		if (WaitForSingleObject(pDlg->m_hCancelTransfer, 0) == WAIT_TIMEOUT)
		{
			if (bWaitForStart)
			{
				DWORD nWritten = 0;
				WriteFile(hCom, FilenamePart, FilenamePart.GetLength(), &nWritten, NULL);
				Status.Format("Waiting for NAK...");
				pDlg->m_Status = Status;
				PostMessage(hWnd, WM_UPDATETEXT, 0, 0);
				char c;
				DWORD nNAKRead = 0;
				ReadFile(hCom, &c, 1, &nNAKRead, NULL);
				if (nNAKRead == 1 && c == 21)
				{
					bWaitForStart = FALSE;
					StartTime = CTime::GetCurrentTime();
				}
				if (nNAKRead == 1 && c == 24)
				{
					bDone = TRUE;
				}
			}
			else
			{
				CTime CurrentTime = CTime::GetCurrentTime();
				CTimeSpan TimeSpan = CurrentTime - StartTime;
				int nSeconds = TimeSpan.GetTotalSeconds();
				if (nSeconds > 10 && nPos > 1024)
					Status.Format("%i of %i bytes sent (%i%%, %i seconds left)", nPos, nSize, nPos * 100 / nSize, nSeconds * nSize / nPos - nSeconds);
				else
					Status.Format("%i of %i bytes sent (%i%%)", nPos, nSize, nPos * 100 / nSize);
				pDlg->m_Status = Status;
				PostMessage(hWnd, WM_UPDATETEXT, 0, 0);
				PostMessage(hWnd, WM_UPDATEPROGRESS, nPos * 100 / nSize, 0);
				memset(pBuffer, 0, BUFFER_SIZE);
				pBuffer[0] = 0x01; // SOH
				pBuffer[1] = (BYTE)nPacket;
				pBuffer[2] = (BYTE)(255) - (BYTE)(nPacket);
				DWORD nRead = 0;
				if (nSize > nPos)
				{
					if (nSize - nPos < 128)
					{
						ReadFile(hFile, &pBuffer[3], nSize - nPos, &nRead, NULL);
					}
					else
					{
						ReadFile(hFile, &pBuffer[3], 128, &nRead, NULL);
					}
				}
				if (nRead == 0 && nPos >= nSize)
				{
					bDone = TRUE;
					char c = 4;
					DWORD nWritten = 0;
					WriteFile(hCom, &c, 1, &nWritten, NULL);
				}
				else
				{
					BYTE CheckSum = 0;
					for (int i = 3; i <= 130; i++)
					{
						CheckSum = (CheckSum + (BYTE)(pBuffer[i])) % 256;
					}
					pBuffer[131] = (char)(CheckSum);
					BOOL bSentOkay = FALSE;
					PurgeComm(hCom, PURGE_TXCLEAR);
					PurgeComm(hCom, PURGE_RXCLEAR);
					DWORD nWritten = 0;
					WriteFile(hCom, pBuffer, BUFFER_SIZE, &nWritten, NULL);
					
					if (nWritten == BUFFER_SIZE)
					{
						char c;
						DWORD nACKRead = 0;
						ReadFile(hCom, &c, 1, &nACKRead, NULL);
						if (nACKRead == 1 && c == 0x06)
						{
							bSentOkay = TRUE;
							nPacket++;
							if (nPacket == 256)
								nPacket = 0;
							nPos += nRead;
						}
						if (nACKRead == 1 && c == 24)
						{
							bDone = TRUE;
						}
					}
					if (!bSentOkay)
						SetFilePointer(hFile, -((int)nRead), NULL, FILE_CURRENT);
				}
			}
		}
		else
		{
			CString CancelString = char(24) + char(24) + char(24);
			DWORD nWritten = 0;
			WriteFile(hCom, CancelString, CancelString.GetLength(), &nWritten, NULL);
			WriteFile(hCom, CancelString, CancelString.GetLength(), &nWritten, NULL);
			bDone = TRUE;
		}
	}
	delete[] pBuffer;
	CloseHandle(hFile);
	CloseHandle(hCom);
	SetEvent(pDlg->m_hTransferDone);
	PostMessage(hWnd, WM_CLOSE, 0, 0);
	return 0;
}

BOOL CTransferInProgressDialog::OnInitDialog() 
{
	CDialog::OnInitDialog();
	m_Status = "";
	m_nCOMPort = GetMainWnd()->GetSettingInt("COMPort");
	m_nBaudRate = GetMainWnd()->GetSettingInt("BaudRate");
	m_hCancelTransfer = CreateEvent(0, FALSE, FALSE, 0);
	m_hTransferDone = CreateEvent(0, FALSE, FALSE, 0);
	m_Progress.SetRange(0, 100);
	m_Progress.SetPos(0);
	UpdateData(FALSE);
	AfxBeginThread((AFX_THREADPROC)XmodemThread, (LPVOID)this);
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CTransferInProgressDialog::Finish()
{
	CloseHandle(m_hCancelTransfer);	
	CloseHandle(m_hTransferDone);	
}

LONG CTransferInProgressDialog::OnUpdateText(UINT, LONG) 
{
	UpdateData(FALSE);
	return 0;
}

LONG CTransferInProgressDialog::OnUpdateProgress(UINT uiPos, LONG) 
{
	m_Progress.SetPos(uiPos);
	return 0;
}

void CTransferInProgressDialog::OnCancel() 
{
	SetEvent(m_hCancelTransfer);
	WaitForSingleObject(m_hTransferDone, 10000);
	
	CDialog::OnCancel();
}
